// CH9130ADC.cpp : implementation file
//

#include "stdafx.h"
#include "ch9130test.h"
#include "CH9130ADC.h"

#include "cfile64.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCH9130ADC property page

void CALLBACK ADCRemoveCallBack(PVOID pParam)
{
	CCH9130Sheet * pSheet = (CCH9130Sheet *)AfxGetMainWnd();
	CCH9130ADC * pThis = (CCH9130ADC *)pSheet->GetPage(8);
	//pThis->PostMessage(MM_MYCHANGEDEVICE);

	if(pThis->m_hDev != NULL)
	{
		CH9130Disconnect(pThis->m_hDev,1000);
		pThis->m_hDev = NULL;
		pThis->PostMessage(MM_MYCHANGEDEVICE);
	}

}

IMPLEMENT_DYNCREATE(CCH9130ADC, CPropertyPage)

CCH9130ADC::CCH9130ADC() : CPropertyPage(CCH9130ADC::IDD)
{
	//{{AFX_DATA_INIT(CCH9130ADC)
	m_uCyc = 0;
	m_uDivClk = 0;
	m_uAutoCnt = 0;
	//}}AFX_DATA_INIT
}

CCH9130ADC::~CCH9130ADC()
{
}

void CCH9130ADC::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCH9130ADC)
	DDX_Control(pDX, IDC_COMBO_ADC_CHANN, m_ctrlChan);
	DDX_Control(pDX, IDC_COMBO_ADC_ATO_WID, m_ctrlAtoWid);
	DDX_Text(pDX, IDC_EDIT_ADC_CYC, m_uCyc);
	DDX_Text(pDX, IDC_EDIT_ADC_DIVCLK, m_uDivClk);
	DDX_Text(pDX, IDC_EDIT_ADC_AUTO_CNT, m_uAutoCnt);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCH9130ADC, CPropertyPage)
	//{{AFX_MSG_MAP(CCH9130ADC)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_ADC, OnButtonOpenAdc)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_ADC, OnButtonCloseAdc)
	ON_BN_CLICKED(IDC_BUTTON_INIT, OnButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_ADC_READ, OnButtonAdcRead)
	ON_BN_CLICKED(IDC_BUTTON_READ_DATA, OnButtonReadData)
	ON_BN_CLICKED(IDC_BUTTON_STOP_READ, OnButtonStopRead)
	ON_BN_CLICKED(IDC_BUTTON_CHANGE_CHANN, OnButtonChangeChann)
	ON_BN_CLICKED(IDC_BUTTON_START_AUTO, OnButtonStartAuto)
	ON_BN_CLICKED(IDC_BUTTON_STOP_AUTO, OnButtonStopAuto)
	ON_MESSAGE(MM_MYCHANGEDEVICE,OnMyChangeDevice)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCH9130ADC message handlers

void CCH9130ADC::OnButtonOpenAdc() 
{
	// TODO: Add your control notification handler code here
	CCH9130TestApp * pThis;
	pThis = (CCH9130TestApp *) AfxGetApp();
	m_hDev = CH9130Connect(pThis->m_uIP,pThis->m_uPort);
	if(m_hDev != NULL)
	{
		USHORT DevStatus;
		if( CH9130GetDevStatus(m_hDev,&DevStatus) )
		{
			if(DevStatus & BIT_PERI_ADC)
			{
				AfxMessageBox("豸ѾԴ");
				CH9130Disconnect(m_hDev,1000);
				m_hDev = NULL;
			}else{
			
				if( CH9130OpenADC(m_hDev) )
				{
					CH9130SetCallBack(m_hDev,ADCRemoveCallBack,NULL);
					AfxMessageBox("ADC򿪳ɹ");
					CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_ADC);
					::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
				}
			}
		}
	}
}

void CCH9130ADC::OnButtonCloseAdc() 
{
	// TODO: Add your control notification handler code here
	if(m_hDev != NULL)
	{
		if(CH9130CloseADC(m_hDev))
		{
			
		}
		CH9130Disconnect(m_hDev,1000);
		m_hDev = NULL;
		CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_ADC);
		::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	}
}

void CCH9130ADC::OnButtonInit() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	
	CString st;
	BOOL bAtoWid;
	m_ctrlAtoWid.GetLBText( m_ctrlAtoWid.GetCurSel() ,st);
	if(st == _T("1ʱ") ){
		bAtoWid = 0;
	}else if(st == _T("2ʱ")){
		bAtoWid = 1;
	}
	if(CH9130InitADC(m_hDev,m_uCyc,bAtoWid,m_uDivClk,0,m_uAutoCnt,0))
	{
	}

}

BOOL CCH9130ADC::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	m_ctrlAtoWid.AddString(_T("1ʱ"));
	m_ctrlAtoWid.AddString(_T("2ʱ"));
	m_ctrlAtoWid.SetCurSel(0);
	
	m_ctrlChan.AddString(_T("0"));
	m_ctrlChan.AddString(_T("1"));
	m_ctrlChan.AddString(_T("2"));
	m_ctrlChan.SetCurSel(0);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CCH9130ADC::OnButtonAdcRead() 
{
	// TODO: Add your control notification handler code here

	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}

	USHORT data;
	if( CH9130ReadADCData(m_hDev,&data) )
	{
		char buffer[sizeof(data)*3];
		memset(buffer,0,sizeof(buffer));
		sprintf(buffer,"%04X",data);
		SetDlgItemText(IDC_EDIT_DATA,buffer);
	}else AfxMessageBox("Ĵʧ");

}

void CCH9130ADC::OnButtonReadData() 
{
	// TODO: Add your control notification handler code here
	m_bStopRead = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_READ_DATA);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	AfxBeginThread(ThreadRecv,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

UINT CCH9130ADC::ThreadRecv(LPVOID pParam)
{
	CCH9130ADC * pThis;
	pThis = (CCH9130ADC * )pParam;
	USHORT buf[1024];
	ULONG len;
	while(TRUE)
	{	
		if(pThis->m_bStopRead) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			return 0;
		}
		len = sizeof(buf);
		memset(buf,0,sizeof(buf));
		if( CH9130ReadADCDataStream(pThis->m_hDev,buf,&len,100) )
		{
			if(len != 0)
			{
				CString stFileName;
				for(UINT index = 0 ; ;index++)
				{
					stFileName.Format("ADCDATA_%d.BIN",index);
					if( GetFileLen(stFileName) < (4194304000) ) break;  //CStdioFileִ֧4GBļ,޶ļС4000*1024*1024
				}

				CStdioFile f;
				
				if(!f.Open(stFileName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
				{
					
				   break;
				}
				f.SeekToEnd();
			
				f.Write(buf,len);
				f.Close();
			}

		}
	}
	return 0;
}

void CCH9130ADC::OnButtonStopRead() 
{
	// TODO: Add your control notification handler code here
	m_bStopRead = TRUE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_READ_DATA);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}

void CCH9130ADC::OnButtonChangeChann() 
{
	// TODO: Add your control notification handler code here
	CString st;
	UCHAR bChan;
	m_ctrlChan.GetLBText( m_ctrlChan.GetCurSel() ,st);
	if(st == _T("0") ){
		bChan = 0;
	}else if(st == _T("1")){
		bChan = 1;
	}else if(st == _T("2")){
		bChan = 2;
	}
	if(CH9130ChangeADCChan(m_hDev,bChan))
	{
		AfxMessageBox("ıͨɹ");
	}
}

void CCH9130ADC::OnButtonStartAuto() 
{
	// TODO: Add your control notification handler code here

	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}

	if(CH9130SetADCAutoData(m_hDev,TRUE))
	{
	
	}
}

void CCH9130ADC::OnButtonStopAuto() 
{
	// TODO: Add your control notification handler code here

	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	if(CH9130SetADCAutoData(m_hDev,FALSE))
	{
	
	}
}
LRESULT CCH9130ADC::OnMyChangeDevice(WPARAM wParam, LPARAM lParam)
{
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_ADC);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	OnButtonStopRead() ;
	return 0;
}