// CH9130GPIO.cpp : implementation file
//

#include "stdafx.h"
#include "ch9130test.h"
#include "CH9130GPIO.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCH9130GPIO property page

void CALLBACK GPIORemoveCallBack(PVOID pParam)
{
	CCH9130Sheet * pSheet = (CCH9130Sheet *)AfxGetMainWnd();
	CCH9130GPIO * pThis = (CCH9130GPIO *)pSheet->GetPage(0);

	if(pThis->m_hDev != NULL)
	{
		CH9130Disconnect(pThis->m_hDev,1000);
		pThis->m_hDev = NULL;
		pThis->PostMessage(MM_MYCHANGEDEVICE);
	}
}

IMPLEMENT_DYNCREATE(CCH9130GPIO, CPropertyPage)

CCH9130GPIO::CCH9130GPIO() : CPropertyPage(CCH9130GPIO::IDD)
{
	//{{AFX_DATA_INIT(CCH9130GPIO)
		// NOTE: the ClassWizard will add member initialization here
	m_hDev = NULL;
	m_usDir = 0;
	//}}AFX_DATA_INIT
}

CCH9130GPIO::~CCH9130GPIO()
{
}

void CCH9130GPIO::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCH9130GPIO)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCH9130GPIO, CPropertyPage)
	//{{AFX_MSG_MAP(CCH9130GPIO)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_GPIO, OnButtonOpenGpio)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_GPIO, OnButtonCloseGpio)
	ON_BN_CLICKED(IDC_RADIO_I0, OnRadioI0)
	ON_BN_CLICKED(IDC_RADIO_O0, OnRadioO0)
	ON_BN_CLICKED(IDC_RADIO_I1, OnRadioI1)
	ON_BN_CLICKED(IDC_RADIO_O1, OnRadioO1)
	ON_BN_CLICKED(IDC_RADIO_I2, OnRadioI2)
	ON_BN_CLICKED(IDC_RADIO_O2, OnRadioO2)
	ON_BN_CLICKED(IDC_RADIO_I3, OnRadioI3)
	ON_BN_CLICKED(IDC_RADIO_O3, OnRadioO3)
	ON_BN_CLICKED(IDC_RADIO_I4, OnRadioI4)
	ON_BN_CLICKED(IDC_RADIO_O4, OnRadioO4)
	ON_BN_CLICKED(IDC_RADIO_I5, OnRadioI5)
	ON_BN_CLICKED(IDC_RADIO_O5, OnRadioO5)
	ON_BN_CLICKED(IDC_RADIO_I6, OnRadioI6)
	ON_BN_CLICKED(IDC_RADIO_O6, OnRadioO6)
	ON_BN_CLICKED(IDC_RADIO_I7, OnRadioI7)
	ON_BN_CLICKED(IDC_RADIO_O7, OnRadioO7)
	ON_BN_CLICKED(IDC_RADIO_I8, OnRadioI8)
	ON_BN_CLICKED(IDC_RADIO_O8, OnRadioO8)
	ON_BN_CLICKED(IDC_RADIO_I9, OnRadioI9)
	ON_BN_CLICKED(IDC_RADIO_O9, OnRadioO9)
	ON_BN_CLICKED(IDC_RADIO_I10, OnRadioI10)
	ON_BN_CLICKED(IDC_RADIO_O10, OnRadioO10)
	ON_BN_CLICKED(IDC_RADIO_I11, OnRadioI11)
	ON_BN_CLICKED(IDC_RADIO_O11, OnRadioO11)
	ON_BN_CLICKED(IDC_RADIO_I12, OnRadioI12)
	ON_BN_CLICKED(IDC_RADIO_O12, OnRadioO12)
	ON_BN_CLICKED(IDC_RADIO_I13, OnRadioI13)
	ON_BN_CLICKED(IDC_RADIO_O13, OnRadioO13)
	ON_BN_CLICKED(IDC_RADIO_I14, OnRadioI14)
	ON_BN_CLICKED(IDC_RADIO_O14, OnRadioO14)
	ON_BN_CLICKED(IDC_RADIO_I15, OnRadioI15)
	ON_BN_CLICKED(IDC_RADIO_O15, OnRadioO15)
	ON_BN_CLICKED(IDC_BUTTON_GPIO_SET, OnButtonGpioSet)
	ON_BN_CLICKED(IDC_BUTTON_GPIO_READ, OnButtonGpioRead)
	ON_BN_CLICKED(IDC_BUTTON_GPIO_WRITE, OnButtonGpioWrite)
	ON_MESSAGE(MM_MYCHANGEDEVICE,OnMyChangeDevice)
	ON_BN_CLICKED(IDC_BUTTON_GPIO_TEST, OnButtonGpioTest)
	ON_BN_CLICKED(IDC_BUTTON_STOP_TEST, OnButtonStopTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCH9130GPIO message handlers

void CCH9130GPIO::OnButtonOpenGpio() 
{
	// TODO: Add your control notification handler code here
	CCH9130TestApp * pThis;
	pThis = (CCH9130TestApp *) AfxGetApp();
	m_hDev = CH9130Connect(pThis->m_uIP,pThis->m_uPort);
	if(m_hDev != NULL)
	{
		USHORT DevStatus;
		if( CH9130GetDevStatus(m_hDev,&DevStatus) )
		{
			if(DevStatus & BIT_PERI_GPIO)
			{
				AfxMessageBox("豸ѾԴ");
				CH9130Disconnect(m_hDev,1000);
				m_hDev = NULL;
			}else{
				if( CH9130OpenGPIO(m_hDev) )
				{
					CH9130SetCallBack(m_hDev,GPIORemoveCallBack,NULL);
					AfxMessageBox("GPIO򿪳ɹ");
					CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_GPIO);
					::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
				}
			}
		}
	}else{
		AfxMessageBox("豸ʧ");
	}
}

void CCH9130GPIO::OnButtonCloseGpio() 
{
	// TODO: Add your control notification handler code here
	if(m_hDev != NULL)
	{
		if(CH9130CloseGPIO(m_hDev))
		{
			
		}
		CH9130Disconnect(m_hDev,1000);
		m_hDev = NULL;
		CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_GPIO);
		::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	}
}

BOOL CCH9130GPIO::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
	CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
	CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
	CheckRadioButton(IDC_RADIO_I3,IDC_RADIO_O3,IDC_RADIO_I3);
	CheckRadioButton(IDC_RADIO_I4,IDC_RADIO_O4,IDC_RADIO_I4);
	CheckRadioButton(IDC_RADIO_I5,IDC_RADIO_O5,IDC_RADIO_I5);
	CheckRadioButton(IDC_RADIO_I6,IDC_RADIO_O6,IDC_RADIO_I6);
	CheckRadioButton(IDC_RADIO_I7,IDC_RADIO_O7,IDC_RADIO_I7);
	CheckRadioButton(IDC_RADIO_I8,IDC_RADIO_O8,IDC_RADIO_I8);
	CheckRadioButton(IDC_RADIO_I9,IDC_RADIO_O9,IDC_RADIO_I9);
	CheckRadioButton(IDC_RADIO_I10,IDC_RADIO_O10,IDC_RADIO_I10);
	CheckRadioButton(IDC_RADIO_I11,IDC_RADIO_O11,IDC_RADIO_I11);
	CheckRadioButton(IDC_RADIO_I12,IDC_RADIO_O12,IDC_RADIO_I12);
	CheckRadioButton(IDC_RADIO_I13,IDC_RADIO_O13,IDC_RADIO_I13);
	CheckRadioButton(IDC_RADIO_I14,IDC_RADIO_O14,IDC_RADIO_I14);
	CheckRadioButton(IDC_RADIO_I15,IDC_RADIO_O15,IDC_RADIO_I15);
	m_usDir = 0;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCH9130GPIO::OnRadioI0() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_I0);
	m_usDir &= ( ~(1<<0) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO0() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I0,IDC_RADIO_O0,IDC_RADIO_O0);
	m_usDir |= (1<<0) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI1() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_I1);
	m_usDir &= ( ~(1<<1) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO1() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I1,IDC_RADIO_O1,IDC_RADIO_O1);
	m_usDir |= (1<<1) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI2() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_I2);
	m_usDir &= ( ~(1<<2) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO2() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I2,IDC_RADIO_O2,IDC_RADIO_O2);
	m_usDir |= (1<<2) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI3() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I3,IDC_RADIO_O3,IDC_RADIO_I3);
	m_usDir &= ( ~(1<<3) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO3() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I3,IDC_RADIO_O3,IDC_RADIO_O3);
	m_usDir |= (1<<3) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI4() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I4,IDC_RADIO_O4,IDC_RADIO_I4);
	m_usDir &= ( ~(1<<4) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO4() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I4,IDC_RADIO_O4,IDC_RADIO_O4);
	m_usDir |= (1<<4) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI5() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I5,IDC_RADIO_O5,IDC_RADIO_I5);
	m_usDir &= ( ~(1<<5) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO5() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I5,IDC_RADIO_O5,IDC_RADIO_O5);
	m_usDir |= (1<<5) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI6() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I6,IDC_RADIO_O6,IDC_RADIO_I6);
	m_usDir &= ( ~(1<<6) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO6() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I6,IDC_RADIO_O6,IDC_RADIO_O6);
	m_usDir |= (1<<6) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI7() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I7,IDC_RADIO_O7,IDC_RADIO_I7);
	m_usDir &= ( ~(1<<7) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO7() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I7,IDC_RADIO_O7,IDC_RADIO_O7);
	m_usDir |= (1<<7) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI8() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I8,IDC_RADIO_O8,IDC_RADIO_I8);
	m_usDir &= ( ~(1<<8) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO8() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I8,IDC_RADIO_O8,IDC_RADIO_O8);
	m_usDir |= (1<<8) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI9() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I9,IDC_RADIO_O9,IDC_RADIO_I9);
	m_usDir &= ( ~(1<<9) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO9() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I9,IDC_RADIO_O9,IDC_RADIO_O9);
	m_usDir |= (1<<9) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI10() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I10,IDC_RADIO_O10,IDC_RADIO_I10);
	m_usDir &= ( ~(1<<10) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO10() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I10,IDC_RADIO_O10,IDC_RADIO_O10);
	m_usDir |= (1<<10) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI11() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I11,IDC_RADIO_O11,IDC_RADIO_I11);
	m_usDir &= ( ~(1<<11) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO11() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I11,IDC_RADIO_O11,IDC_RADIO_O11);
	m_usDir |= (1<<11) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI12() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I12,IDC_RADIO_O12,IDC_RADIO_I12);
	m_usDir &= ( ~(1<<12) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO12() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I12,IDC_RADIO_O12,IDC_RADIO_O12);
	m_usDir |= (1<<12) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI13() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I13,IDC_RADIO_O13,IDC_RADIO_I13);
	m_usDir &= ( ~(1<<13) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO13() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I13,IDC_RADIO_O13,IDC_RADIO_O13);
	m_usDir |= (1<<13) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI14() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I14,IDC_RADIO_O14,IDC_RADIO_I14);
	m_usDir &= ( ~(1<<14) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO14() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I14,IDC_RADIO_O14,IDC_RADIO_O14);
	m_usDir |= (1<<14) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioI15() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I15,IDC_RADIO_O15,IDC_RADIO_I15);
	m_usDir &= ( ~(1<<15) );
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnRadioO15() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_RADIO_I15,IDC_RADIO_O15,IDC_RADIO_O15);
	m_usDir |= (1<<15) ;
	CString st;
	st.Format("%04X",m_usDir);
	SetDlgItemText(IDC_EDIT_GPIO_DIR,st);
}

void CCH9130GPIO::OnButtonGpioSet() 
{
	// TODO: Add your control notification handler code here
	if(m_hDev !=NULL)
	{
		UCHAR data;


		
		data = (UCHAR) m_usDir;
		CH9130SetGPIODir0(m_hDev,data);

		data = (UCHAR) (m_usDir>>8);
		CH9130SetGPIODir1(m_hDev,data);
	}
}

void CCH9130GPIO::OnButtonGpioRead() 
{
	// TODO: Add your control notification handler code here
	if(m_hDev !=NULL)
	{
		UCHAR data;
		if( CH9130ReadGPIOData0(m_hDev,&data) )
		{
			
			if( data & (1<<0) )
			{
				CheckDlgButton(IDC_CHECK_IO0,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO0,BST_UNCHECKED);
			}
			
			if( data & (1<<1) )
			{
				CheckDlgButton(IDC_CHECK_IO1,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO1,BST_UNCHECKED);
			}

			if( data & (1<<2) )
			{
				CheckDlgButton(IDC_CHECK_IO2,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO2,BST_UNCHECKED);
			}

			if( data & (1<<3) )
			{
				CheckDlgButton(IDC_CHECK_IO3,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO3,BST_UNCHECKED);
			}

			if( data & (1<<4) )
			{
				CheckDlgButton(IDC_CHECK_IO4,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO4,BST_UNCHECKED);
			}
			
			if( data & (1<<5) )
			{
				CheckDlgButton(IDC_CHECK_IO5,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO5,BST_UNCHECKED);
			}

			if( data & (1<<6) )
			{
				CheckDlgButton(IDC_CHECK_IO6,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO6,BST_UNCHECKED);
			}

			if( data & (1<<7) )
			{
				CheckDlgButton(IDC_CHECK_IO7,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO7,BST_UNCHECKED);
			}
		}

		if( CH9130ReadGPIOData1(m_hDev,&data) )
		{
			
			if( data & (1<<0) )
			{
				CheckDlgButton(IDC_CHECK_IO8,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO8,BST_UNCHECKED);
			}
			
			if( data & (1<<1) )
			{
				CheckDlgButton(IDC_CHECK_IO9,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO9,BST_UNCHECKED);
			}

			if( data & (1<<2) )
			{
				CheckDlgButton(IDC_CHECK_IO10,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO10,BST_UNCHECKED);
			}

			if( data & (1<<3) )
			{
				CheckDlgButton(IDC_CHECK_IO11,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO11,BST_UNCHECKED);
			}

			if( data & (1<<4) )
			{
				CheckDlgButton(IDC_CHECK_IO12,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO12,BST_UNCHECKED);
			}
			
			if( data & (1<<5) )
			{
				CheckDlgButton(IDC_CHECK_IO13,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO13,BST_UNCHECKED);
			}

			if( data & (1<<6) )
			{
				CheckDlgButton(IDC_CHECK_IO14,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO14,BST_UNCHECKED);
			}

			if( data & (1<<7) )
			{
				CheckDlgButton(IDC_CHECK_IO15,BST_CHECKED);
			}else{
				CheckDlgButton(IDC_CHECK_IO15,BST_UNCHECKED);
			}
		}
	}
}

void CCH9130GPIO::OnButtonGpioWrite() 
{
	// TODO: Add your control notification handler code here

	UCHAR data;
	data = 0;
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO0) == BST_CHECKED )
	{
		data |= (1<<0);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO1) == BST_CHECKED )
	{
		data |= (1<<1);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO2) == BST_CHECKED )
	{
		data |= (1<<2);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO3) == BST_CHECKED )
	{
		data |= (1<<3);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO4) == BST_CHECKED )
	{
		data |= (1<<4);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO5) == BST_CHECKED )
	{
		data |= (1<<5);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO6) == BST_CHECKED )
	{
		data |= (1<<6);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO7) == BST_CHECKED )
	{
		data |= (1<<7);
	}

	if( CH9130WriteGPIOData0(m_hDev,data) )
	{
	}
	
	data = 0;
	if( IsDlgButtonChecked(IDC_CHECK_IO8) == BST_CHECKED )
	{
		data |= (1<<0);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO9) == BST_CHECKED )
	{
		data |= (1<<1);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO10) == BST_CHECKED )
	{
		data |= (1<<2);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO11) == BST_CHECKED )
	{
		data |= (1<<3);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO12) == BST_CHECKED )
	{
		data |= (1<<4);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO13) == BST_CHECKED )
	{
		data |= (1<<5);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO14) == BST_CHECKED )
	{
		data |= (1<<6);
	}
	if( IsDlgButtonChecked(IDC_CHECK_IO15) == BST_CHECKED )
	{
		data |= (1<<7);
	}
	if( CH9130WriteGPIOData0(m_hDev,data) )
	{
	}
}

//DEL void CCH9130GPIO::OnButtonTest() 
//DEL {
//DEL 	// TODO: Add your control notification handler code here
//DEL 	ULONG uDevWDTAddr,CtrlParam ;
//DEL 	uDevWDTAddr = 0x00D00000+0x019;
//DEL 	CtrlParam = BIT_CTL_PARAM_REG_CFG | BIT_CTL_PARAM_REG_VIR;
//DEL 	if(!CH9130WriteRegByte(m_hDev,uDevWDTAddr,0,CtrlParam,20000) )
//DEL 	{
//DEL 		
//DEL 	}
//DEL }

LRESULT CCH9130GPIO::OnMyChangeDevice(WPARAM wParam, LPARAM lParam)
{
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_GPIO);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

UINT CCH9130GPIO::ThreadGPIOTest(LPVOID pParam)
{
	CCH9130GPIO * pThis;
	
	pThis = (CCH9130GPIO * )pParam;

	UCHAR data;
	data = 0x55;
	while(TRUE)
	{
		if(pThis->m_bStopTest) break;
		

		if( CH9130WriteGPIOData0(pThis->m_hDev,data) )
		{
		}

		if( CH9130WriteGPIOData1(pThis->m_hDev,data) )
		{
		}
		Sleep(100);
		data ^= 0xFF;
	}
	CWnd * pwnd = pThis->GetDlgItem(IDC_BUTTON_GPIO_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

void CCH9130GPIO::OnButtonGpioTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopTest = FALSE;
	
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_GPIO_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	
	AfxBeginThread(ThreadGPIOTest,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

void CCH9130GPIO::OnButtonStopTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopTest = TRUE;
}
