// CH9130PARA.cpp : implementation file
//

#include "stdafx.h"
#include "ch9130test.h"
#include "CH9130PARA.h"

#include "cfile64.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCH9130PARA property page

void CALLBACK PARARemoveCallBack(PVOID pParam)
{
	CCH9130Sheet * pSheet = (CCH9130Sheet *)AfxGetMainWnd();
	CCH9130PARA * pThis = (CCH9130PARA *)pSheet->GetPage(9);

	if(pThis->m_hDev != NULL)
	{
		CH9130Disconnect(pThis->m_hDev,1000);
		pThis->m_hDev = NULL;
		pThis->PostMessage(MM_MYCHANGEDEVICE);
	}
}

IMPLEMENT_DYNCREATE(CCH9130PARA, CPropertyPage)

CCH9130PARA::CCH9130PARA() : CPropertyPage(CCH9130PARA::IDD)
{
	//{{AFX_DATA_INIT(CCH9130PARA)
	m_uHoldCyc = 0;
	m_uRWCyc = 0;
	m_uTime = 0;
	m_uOffset = 0;
	//}}AFX_DATA_INIT
}

CCH9130PARA::~CCH9130PARA()
{
}

void CCH9130PARA::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCH9130PARA)
	DDX_Control(pDX, IDC_COMBO_PARA_INC, m_ctrlInc);
	DDX_Control(pDX, IDC_COMBO_PARA_WIDTH, m_ctrlWidth);
	DDX_Control(pDX, IDC_COMBO_PARA_MODE, m_ctrlMode);
	DDX_Control(pDX, IDC_COMBO_PARA_CYC, m_ctrlCyc);
	DDX_Text(pDX, IDC_EDIT_PARA_HOLD_CYC, m_uHoldCyc);
	DDX_Text(pDX, IDC_EDIT_PARA_RWCYC, m_uRWCyc);
	DDX_Text(pDX, IDC_EDIT_PARA_TIME, m_uTime);
	DDX_Text(pDX, IDC_EDIT_PARA_OFFSET, m_uOffset);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCH9130PARA, CPropertyPage)
	//{{AFX_MSG_MAP(CCH9130PARA)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_PARA, OnButtonOpenPara)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_PARA, OnButtonClosePara)
	ON_BN_CLICKED(IDC_BUTTON_INIT, OnButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_PARA_READ, OnButtonParaRead)
	ON_BN_CLICKED(IDC_BUTTON_PARA_WRITE, OnButtonParaWrite)
	ON_BN_CLICKED(IDC_BUTTON_SLV_PARA_READ, OnButtonSlvParaRead)
	ON_BN_CLICKED(IDC_BUTTON_SLV_PARA_STOP, OnButtonSlvParaStop)
	ON_BN_CLICKED(IDC_BUTTON_SLV_PARA_WRITE, OnButtonSlvParaWrite)
	ON_MESSAGE(MM_MYCHANGEDEVICE,OnMyChangeDevice)
	ON_BN_CLICKED(IDC_BUTTON_SEND_RECV_FILE, OnButtonSendRecvFile)
	ON_BN_CLICKED(IDC_BUTTON_SEND_FILE, OnButtonSendFile)
	ON_BN_CLICKED(IDC_BUTTON_PARA_TEST, OnButtonParaTest)
	ON_BN_CLICKED(IDC_BUTTON_SLV_TEST, OnButtonSlvTest)
	ON_BN_CLICKED(IDC_BUTTON_STOP_TEST, OnButtonStopTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCH9130PARA message handlers

void CCH9130PARA::OnButtonOpenPara() 
{
	// TODO: Add your control notification handler code here
	CCH9130TestApp * pThis;
	pThis = (CCH9130TestApp *) AfxGetApp();
	m_hDev = CH9130Connect(pThis->m_uIP,pThis->m_uPort);
	if(m_hDev != NULL)
	{
		USHORT DevStatus;
		if( CH9130GetDevStatus(m_hDev,&DevStatus) )
		{
			if(DevStatus & BIT_PERI_PARA)
			{
				AfxMessageBox("豸ѾԴ");
				CH9130Disconnect(m_hDev,1000);
				m_hDev = NULL;
			}else{
				if( CH9130OpenPARA(m_hDev) )
				{
					CH9130SetCallBack(m_hDev,PARARemoveCallBack,NULL);
					AfxMessageBox("PARA򿪳ɹ");
					CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_PARA);
					::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
				}
			}
		}
	}
}

void CCH9130PARA::OnButtonClosePara() 
{
	// TODO: Add your control notification handler code here
	if(m_hDev != NULL)
	{
		if(CH9130ClosePARA(m_hDev))
		{
			
		}
		CH9130Disconnect(m_hDev,1000);
		m_hDev = NULL;
		CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_PARA);
		::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	}
}

void CCH9130PARA::OnButtonInit() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	
	CString st;
	BOOL bMode,bCyc,bAtf,bWidth;
	m_ctrlMode.GetLBText( m_ctrlMode.GetCurSel() ,st);
	if(st == _T("") ){
		bMode = 0;
	}else if(st == _T("")){
		bMode = 1;
	}

	m_ctrlCyc.GetLBText( m_ctrlCyc.GetCurSel() ,st);
	if(st == _T("1ʱ") ){
		bCyc = 0;
	}else if(st == _T("2ʱ")){
		bCyc = 1;
	}


	bAtf = 1;

	m_ctrlWidth.GetLBText( m_ctrlWidth.GetCurSel() ,st);
	if(st == _T("8λ") ){
		bWidth = 0;
	}else if(st == _T("16λ")){
		bWidth = 1;
	}
	if(CH9130InitPARA(m_hDev,bMode,bCyc,bWidth,bAtf,m_uRWCyc,m_uHoldCyc))
	{
	}
}

BOOL CCH9130PARA::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	m_ctrlMode.AddString(_T(""));
	m_ctrlMode.AddString(_T(""));
	m_ctrlMode.SetCurSel(0);
	
	m_ctrlCyc.AddString(_T("1ʱ"));
	m_ctrlCyc.AddString(_T("2ʱ"));
	m_ctrlCyc.SetCurSel(0);



	m_ctrlWidth.AddString(_T("8λ"));
	m_ctrlWidth.AddString(_T("16λ"));
	m_ctrlWidth.SetCurSel(0);
	
	m_ctrlInc.AddString(_T(""));
	m_ctrlInc.AddString(_T(""));
	m_ctrlInc.SetCurSel(1);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCH9130PARA::OnButtonParaRead() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	CString st;
	BOOL bWidth,bInc;

	m_ctrlWidth.GetLBText( m_ctrlWidth.GetCurSel() ,st);
	if(st == _T("8λ") ){
		bWidth = 0;
	}else if(st == _T("16λ")){
		bWidth = 1;
	}
	m_ctrlInc.GetLBText( m_ctrlInc.GetCurSel() ,st);
	if(st == _T("") ){
		bInc = 1;
	}else if(st == _T("")){
		bInc = 0;
	}
	if(bWidth)
	{
		ULONG uReadLen = m_uTime*2;
		PCHAR data = (PCHAR)malloc(uReadLen);
		PCHAR buffer = (PCHAR)malloc(uReadLen*2+1);
		if( CH9130ReadMasterPARAWord(m_hDev,m_uOffset,bInc,data,uReadLen,1000) )
		{
			memset(buffer,0,uReadLen*2);
			for(UINT i = 0,j=0 ; i < uReadLen; i++ )
			{
				sprintf(&buffer[j],"%02X",(UCHAR)data[i]);
				j+=2;
			}
			SetDlgItemText(IDC_EDIT_DATA,buffer);
		}else AfxMessageBox("Ĵʧ");
		free(data);
		free(buffer);
	}else{
		ULONG uReadLen = m_uTime;
		PCHAR data = (PCHAR)malloc(uReadLen);
		PCHAR buffer = (PCHAR)malloc(uReadLen*2+1);
		if( CH9130ReadMasterPARAByte(m_hDev,m_uOffset,bInc,data,uReadLen,1000) )
		{
			memset(buffer,0,uReadLen*2);
			for(UINT i = 0,j=0 ; i < uReadLen; i++ )
			{
				sprintf(&buffer[j],"%02X",(UCHAR)data[i]);
				j+=2;
			}
			SetDlgItemText(IDC_EDIT_DATA,buffer);
		}else AfxMessageBox("Ĵʧ");
		free(data);
		free(buffer);
	}
}

void CCH9130PARA::OnButtonParaWrite() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	
	CString st;
	BOOL bWidth,bInc;

	m_ctrlWidth.GetLBText( m_ctrlWidth.GetCurSel() ,st);
	if(st == _T("8λ") ){
		bWidth = 0;
	}else if(st == _T("16λ")){
		bWidth = 1;
	}
	m_ctrlInc.GetLBText( m_ctrlInc.GetCurSel() ,st);
	if(st == _T("") ){
		bInc = 1;
	}else if(st == _T("")){
		bInc = 0;
	}
	
	ULONG uWriteLen ;
	uWriteLen = ::GetWindowTextLength(GetDlgItem(IDC_EDIT_DATA)->GetSafeHwnd());

	PCHAR data = (PCHAR)malloc(uWriteLen);
	PCHAR buffer = (PCHAR)malloc(uWriteLen*2+1);
	if( !GetDlgItemText(IDC_EDIT_DATA,buffer,uWriteLen*2+1) )
	{
		AfxMessageBox("Ϊգ!");
		return;
	}
	if(!mCheckInput((PUCHAR)buffer))
	{
		AfxMessageBox("ַ0~9,a~f,A~F֮ʮ!");
		return;
	}
	//data = (USHORT)mStrToBcd(buffer);
	ULONG datalen = strlen(buffer);
	datalen = datalen &0xfffffffe;
	datalen = datalen/2;
	memset(data,0,datalen);
	for(UINT i = 0,j=0; i < datalen*2; i +=2 )
	{
		data[j] = mWordToByte(buffer[i],buffer[i+1]);
		j++;
	}
	
	ULONG uReadLen = datalen;
	
	if(bWidth)
	{
		
		if( CH9130WriteMasterPARAWord(m_hDev,m_uOffset,bInc,data,uReadLen,1000) )
		{

		}else AfxMessageBox("дĴʧ");

	}else{
		
		if( CH9130WriteMasterPARAByte(m_hDev,m_uOffset,bInc,data,uReadLen,1000) )
		{

		}else AfxMessageBox("дĴʧ");
		
	}

	free(data);
	free(buffer);
}

void CCH9130PARA::OnButtonSlvParaRead() 
{
	// TODO: Add your control notification handler code here
	m_bStopRead = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SLV_PARA_READ);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	AfxBeginThread(ThreadRecv,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

UINT CCH9130PARA::ThreadRecv(LPVOID pParam)
{
	CCH9130PARA * pThis;
	pThis = (CCH9130PARA * )pParam;
	UCHAR buf[2048];
	ULONG len;
	while(TRUE)
	{	
		if(pThis->m_bStopRead) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			return 0;
		}
		len = sizeof(buf);
		memset(buf,0,sizeof(buf));
		if( CH9130ReadSlavePARAData(pThis->m_hDev,buf,&len,5000) )
		{
			if(len != 0)
			{
				CString stFileName;
				for(UINT index = 0 ; ;index++)
				{
					stFileName.Format("SLVPARADATA_%d.BIN",index);
					if( GetFileLen(stFileName) < (4194304000) ) break;  //CStdioFileִ֧4GBļ,޶ļС4000*1024*1024
				}

				CStdioFile f;
				
				if(!f.Open(stFileName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
				{
					
				   break;
				}
				f.SeekToEnd();
			
				f.Write(buf,len);
				f.Close();
			}
			Sleep(0);

		}
	}
	return 0;
}

void CCH9130PARA::OnButtonSlvParaStop() 
{
	// TODO: Add your control notification handler code here
	m_bStopRead = TRUE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SLV_PARA_READ);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}

void CCH9130PARA::OnButtonSlvParaWrite() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	
	
	
	ULONG uWriteLen ;
	uWriteLen = ::GetWindowTextLength(GetDlgItem(IDC_EDIT_DATA)->GetSafeHwnd());

	PCHAR data = (PCHAR)malloc(uWriteLen);
	PCHAR buffer = (PCHAR)malloc(uWriteLen*2+1);
	if( !GetDlgItemText(IDC_EDIT_DATA,buffer,uWriteLen*2+1) )
	{
		AfxMessageBox("Ϊգ!");
		return;
	}
	if(!mCheckInput((PUCHAR)buffer))
	{
		AfxMessageBox("ַ0~9,a~f,A~F֮ʮ!");
		return;
	}
	//data = (USHORT)mStrToBcd(buffer);
	ULONG datalen = strlen(buffer);
	datalen = datalen &0xfffffffe;
	datalen = datalen/2;
	//memset(data,0,datalen);
	for(UINT i = 0,j=0; i < datalen*2; i +=2 )
	{
		data[j] = mWordToByte(buffer[i],buffer[i+1]);
		j++;
	}
	
	uWriteLen = datalen;

	if( CH9130WriteSlavePARAData(m_hDev,data,uWriteLen,20000))
	{

	}else AfxMessageBox("дĴʧ");

	free(data);
	free(buffer);
}

LRESULT CCH9130PARA::OnMyChangeDevice(WPARAM wParam, LPARAM lParam)
{
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_PARA);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	OnButtonSlvParaStop();
	m_bStopSend = TRUE;
	return 0;
}

void CCH9130PARA::OnButtonSendRecvFile() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SEND_RECV_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	
	TCHAR szFilters[]= _T("BIN Files (*.BIN)|*.BIN|All Files (*.*)|*.*||");
	TCHAR CurPathName[512];
	GetCurrentDirectory(sizeof(CurPathName),CurPathName);
	// Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg(TRUE, _T("BIN"), _T("*.BIN"),
	  OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilters);

	// Display the file dialog. When user clicks OK, fileDlg.DoModal() 
	// returns IDOK.
	if(fileDlg.DoModal() == IDOK)
	{
		m_strPathName = fileDlg.GetPathName();
		SetCurrentDirectory(CurPathName);
		//AfxMessageBox(m_strPathName);
		AfxBeginThread(ThreadSendRecvFile,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
	}else ::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}

UINT CCH9130PARA::ThreadSendRecvFile(LPVOID pParam)
{
	CCH9130PARA * pThis;
	CStdioFile f,fRecv;
	CString strRecvPathName;
	pThis = (CCH9130PARA * )pParam;
	UCHAR buf[512];
	ULONG len;
	
	strRecvPathName = pThis->m_strPathName + ".r";
	if(!f.Open(pThis->m_strPathName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
	{
	   return 0;
	}
	if(!fRecv.Open(strRecvPathName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
	{
	   return 0;
	}

	CString st;
	BOOL bWidth,bInc;

	pThis->m_ctrlWidth.GetLBText( pThis->m_ctrlWidth.GetCurSel() ,st);
	if(st == _T("8λ") ){
		bWidth = 0;
	}else if(st == _T("16λ")){
		bWidth = 1;
	}
	pThis->m_ctrlInc.GetLBText( pThis->m_ctrlInc.GetCurSel() ,st);
	if(st == _T("") ){
		bInc = 1;
	}else if(st == _T("")){
		bInc = 0;
	}

	while(TRUE)
	{	
		if(pThis->m_bStopSend) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			break;
		}

		len = f.Read(buf,sizeof(buf));
		if(len > 0)
		{
			
			if(bWidth)
			{
				
				if( CH9130WriteMasterPARAByte(pThis->m_hDev,pThis->m_uOffset,bInc,buf,len,10000) )
				{
					Sleep(200);
					if(CH9130ReadMasterPARAByte(pThis->m_hDev,pThis->m_uOffset,bInc,buf,len,10000))
					{
						fRecv.Write(buf,len);
					}
					
				}else break;

			}else{
				if(len != sizeof(buf)) len = len &0xFFFFFFFE; //ȡ

				if( CH9130WriteMasterPARAWord(pThis->m_hDev,pThis->m_uOffset,bInc,buf,len,10000) )
				{
					Sleep(200);
					if(CH9130ReadMasterPARAWord(pThis->m_hDev,pThis->m_uOffset,bInc,buf,len,10000))
					{
						fRecv.Write(buf,len);
					}
				}else break;

				
				
			}
		}else{
			break;
		}
	}
	f.Close();
	fRecv.Close();
	CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SEND_RECV_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

void CCH9130PARA::OnButtonSendFile() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SEND_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	
	TCHAR szFilters[]= _T("BIN Files (*.BIN)|*.BIN|All Files (*.*)|*.*||");
	TCHAR CurPathName[512];
	GetCurrentDirectory(sizeof(CurPathName),CurPathName);
	// Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg(TRUE, _T("BIN"), _T("*.BIN"),
	  OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilters);

	// Display the file dialog. When user clicks OK, fileDlg.DoModal() 
	// returns IDOK.
	if(fileDlg.DoModal() == IDOK)
	{
		m_strPathName = fileDlg.GetPathName();
		SetCurrentDirectory(CurPathName);
		//AfxMessageBox(m_strPathName);
		AfxBeginThread(ThreadSendFile,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
	}else ::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}

UINT CCH9130PARA::ThreadSendFile(LPVOID pParam)
{
	CCH9130PARA * pThis;
	CStdioFile f,fRecv;
	pThis = (CCH9130PARA * )pParam;
	UCHAR buf[512];
	ULONG len;
	
	CString strRecvPathName;
	strRecvPathName = pThis->m_strPathName + ".r";
	if(!f.Open(pThis->m_strPathName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
	{
	   return 0;
	}
	if(!fRecv.Open(strRecvPathName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
	{
	   return 0;
	}
	while(TRUE)
	{	
		if(pThis->m_bStopSend) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			break;
		}

		len = f.Read(buf,sizeof(buf));
		if(len > 0)
		{
			if( CH9130WriteSlavePARAData(pThis->m_hDev,buf,len,10000) )
			{
				
				if( CH9130ReadSlavePARAData(pThis->m_hDev,buf,&len,10000) )
				{
					if(len != 0)
						fRecv.Write(buf,len);
				}
				
			}else break;
		}else{
			break;
		}
	}
	f.Close();
	fRecv.Close();
	CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SEND_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);

	return 0;
}

UINT CCH9130PARA::ThreadHostSendRecvTest(LPVOID pParam)
{
	CCH9130PARA * pThis;
	
	pThis = (CCH9130PARA * )pParam;
	UCHAR SendBuf[512],RecvBuf[512];
	ULONG len;
	ULONGLONG TotalByte = 0;
	ULONG TestTime = 0;

	CTime TestStartTime = CTime::GetCurrentTime(); 
	CTimeSpan ts1(TestStartTime.GetDay(),TestStartTime.GetHour(),
					TestStartTime.GetMinute(),TestStartTime.GetSecond());

	CString st;
	BOOL bWidth,bInc;

	pThis->m_ctrlWidth.GetLBText( pThis->m_ctrlWidth.GetCurSel() ,st);
	if(st == _T("8λ") ){
		bWidth = 0;
	}else if(st == _T("16λ")){
		bWidth = 1;
	}
	pThis->m_ctrlInc.GetLBText( pThis->m_ctrlInc.GetCurSel() ,st);
	if(st == _T("") ){
		bInc = 1;
	}else if(st == _T("")){
		bInc = 0;
	}
	srand( (unsigned int)time( NULL ) );
	UCHAR dIndex = 0;

	while(TRUE)
	{	
		if(pThis->m_bStopSend) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			break;
		}

		//len = f.Read(buf,sizeof(buf));
		len = RangedRand(7,512);
		USHORT datlen = (USHORT)(len -6);
		SendBuf[0] = 'P';
		SendBuf[1] = 'A';
		SendBuf[2] = 'R';
		SendBuf[3] = 'A';
		SendBuf[4] = (UCHAR)datlen;
		SendBuf[5] = (UCHAR)(datlen>>8);
		dIndex = 0;
		for(UINT i = 6 ; i < len ; i ++)
		{
			//SendBuf[i] = (UCHAR)RangedRand(0,256);
			SendBuf[i] = dIndex++;
		}
		TestTime ++;
		TotalByte += len;
		//dIndex++;
		if(len > 0)
		{
			
			if(bWidth )
			{
				len = len &0xFFFFFFFE; //ȡ
				if( CH9130WriteMasterPARAWord(pThis->m_hDev,pThis->m_uOffset,bInc,SendBuf,len,10000) )
				{
					//Sleep(200);
					if(CH9130ReadMasterPARAWord(pThis->m_hDev,pThis->m_uOffset,bInc,RecvBuf,len,10000))
					{
						for(UINT i = 0 ; i < len ; i++)
						{
							if(SendBuf[i] != RecvBuf[i])
							{
								CTime t = CTime::GetCurrentTime();   
								CString st;
								st.Format("ݱȽϴʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
								AfxMessageBox(st);
								//break;
								CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_PARA_TEST);
								::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
								return 0;
							}
						}
					}else{
						CTime t = CTime::GetCurrentTime();   
						CString st;
						st.Format("ڶݴʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
						AfxMessageBox(st);
						break;
					}
					
				}else {
					CTime t = CTime::GetCurrentTime();   
					CString st;
					st.Format("дݴʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
					AfxMessageBox(st);
					break;
				}

			}else{
				

				if( CH9130WriteMasterPARAByte(pThis->m_hDev,pThis->m_uOffset,bInc,SendBuf,len,10000) )
				{
					//Sleep(200);
					if(CH9130ReadMasterPARAByte(pThis->m_hDev,pThis->m_uOffset,bInc,RecvBuf,len,10000))
					{
						for(UINT i = 0 ; i < len ; i++)
						{
							if(SendBuf[i] != RecvBuf[i])
							{
								CTime t = CTime::GetCurrentTime();   
								CString st;
								st.Format("ݱȽϴʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
								AfxMessageBox(st);
								//break;
								CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_PARA_TEST);
								::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
								return 0;
							}
						}
					}else{
						CTime t = CTime::GetCurrentTime();   
						CString st;
						st.Format("ڶݴʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
						AfxMessageBox(st);
						break;
					}
				}else {
					CTime t = CTime::GetCurrentTime();   
					CString st;
					st.Format("дݴʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
					AfxMessageBox(st);
					break;
				}

				
				
			}

			if( (TestTime%10 ) == 9)
			{
				CTime TestCurrentTime = CTime::GetCurrentTime(); 
				CTimeSpan ts2(TestCurrentTime.GetDay(),TestCurrentTime.GetHour(),
						TestCurrentTime.GetMinute(),TestCurrentTime.GetSecond());
				ts2 = ts2-ts1;
				ULONG gb = TotalByte/(0x40000000L);
				ULONG mb = (TotalByte - gb*0x40000000L)/(1024*1024);
				ULONG kb = ( TotalByte - gb*0x40000000L - mb*(1024*1024) ) /1024;
				CString st;
				st.Format("ʱ䣺%s %d ֽ%dGB.%dMB.%dKB",ts2.Format("%D days %H:%M:%S"),TestTime,gb,mb,kb);
				pThis->SetDlgItemText(IDC_EDIT_STATUS,st);
			}
		}else{
			break;
		}
	}

	CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_PARA_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

UINT CCH9130PARA::ThreadSlvSendRecvTest(LPVOID pParam)
{
	CCH9130PARA * pThis;

	pThis = (CCH9130PARA * )pParam;
	UCHAR SendBuf[512],RecvBuf[512];
	ULONG len,RecvLen,RecvLenTemp;
	ULONGLONG TotalByte = 0;
	ULONG TestTime = 0;

	CTime TestStartTime = CTime::GetCurrentTime(); 
	CTimeSpan ts1(TestStartTime.GetDay(),TestStartTime.GetHour(),
					TestStartTime.GetMinute(),TestStartTime.GetSecond());
	
	UCHAR tIndex = 0;
	while(TRUE)
	{	
		if(pThis->m_bStopSend) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			break;
		}

		len = RangedRand(7,512);
		USHORT datlen = (USHORT)(len -6);
		SendBuf[0] = 'P';
		SendBuf[1] = 'A';
		SendBuf[2] = 'R';
		SendBuf[3] = 'A';
		SendBuf[4] = (UCHAR)datlen;
		SendBuf[5] = (UCHAR)(datlen>>8);
		tIndex = 0;
		for(UINT i = 6 ; i < len ; i ++)
		{
			//SendBuf[i] = (UCHAR)RangedRand(0,256);
			SendBuf[i] = (UCHAR)tIndex++;
			
		}
		//tIndex++;
		TestTime ++;
		TotalByte += len;
		
		if( CH9130WriteSlavePARAData(pThis->m_hDev,SendBuf,len,10000) )
		{
			
			RecvLen = 0;
			UINT time = 0;
			do{
				RecvLenTemp = len-RecvLen;
				if(CH9130ReadSlavePARAData(pThis->m_hDev,&RecvBuf[RecvLen],&RecvLenTemp,1000) )
				{
					RecvLen += RecvLenTemp;
					time ++;
				}else{
					CTime t = CTime::GetCurrentTime();   
					CString st;
					st.Format("ڶݴ ʱ%s  ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
					AfxMessageBox(st);
					CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SEND_FILE);
					::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
					return 0;
				}
				if(RecvLen == len) break;
				if(time > 10) break;
			}while(TRUE);
			
			if(RecvLen != len)
			{
			
				CTime t = CTime::GetCurrentTime();   
				CString st;
				st.Format("ڶݳȴʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
				AfxMessageBox(st);
				
				CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SEND_FILE);
				::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
				return 0;
		
			}
			for(UINT i = 0 ; i < len ; i++)
			{
				if(SendBuf[i] != RecvBuf[i])
				{
					CTime t = CTime::GetCurrentTime();   
					CString st;
					st.Format("ݱȽϴʱ䣺%s  s:%02X r:%02x i:%d ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),SendBuf[i], RecvBuf[i],i,(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
					AfxMessageBox(st);
					//break;
					CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SEND_FILE);
					::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
					return 0;
				}
			}
			
		}else {
			CTime t = CTime::GetCurrentTime();   
			CString st;
			st.Format("дݴʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
			AfxMessageBox(st);
			break;
		}
		if( (TestTime%10 ) == 9)
		{
			CTime TestCurrentTime = CTime::GetCurrentTime(); 
			CTimeSpan ts2(TestCurrentTime.GetDay(),TestCurrentTime.GetHour(),
					TestCurrentTime.GetMinute(),TestCurrentTime.GetSecond());
			ts2 = ts2-ts1;
			ULONG gb = TotalByte/(0x40000000L);
			ULONG mb = (TotalByte - gb*0x40000000L)/(1024*1024);
			ULONG kb = ( TotalByte - gb*0x40000000L - mb*(1024*1024) ) /1024;
			CString st;
			st.Format("ʱ䣺%s %d ֽ%dGB.%dMB.%dKB",ts2.Format("%D days %H:%M:%S"),TestTime,gb,mb,kb);
			pThis->SetDlgItemText(IDC_EDIT_STATUS,st);
		}
	}


	CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SEND_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);

	return 0;
}

void CCH9130PARA::OnButtonParaTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_PARA_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	
	
	AfxBeginThread(ThreadHostSendRecvTest,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
	
}

void CCH9130PARA::OnButtonSlvTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SLV_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	
	
	AfxBeginThread(ThreadSlvSendRecvTest,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

void CCH9130PARA::OnButtonStopTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = TRUE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_PARA_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	pwnd = GetDlgItem(IDC_BUTTON_SLV_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}
