// CH9130PWM1.cpp : implementation file
//

#include "stdafx.h"
#include "ch9130test.h"
#include "CH9130PWM1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCH9130PWM1 property page
void CALLBACK PWM1RemoveCallBack(PVOID pParam)
{
	CCH9130Sheet * pSheet = (CCH9130Sheet *)AfxGetMainWnd();
	CCH9130PWM1 * pThis = (CCH9130PWM1 *)pSheet->GetPage(4);

	if(pThis->m_hDev != NULL)
	{
		CH9130Disconnect(pThis->m_hDev,1000);
		pThis->m_hDev = NULL;
		pThis->PostMessage(MM_MYCHANGEDEVICE);
	}
}

IMPLEMENT_DYNCREATE(CCH9130PWM1, CPropertyPage)

CCH9130PWM1::CCH9130PWM1() : CPropertyPage(CCH9130PWM1::IDD)
{
	//{{AFX_DATA_INIT(CCH9130PWM1)
	m_uCYC = 0;
	m_uDuty = 50;
	//}}AFX_DATA_INIT
}

CCH9130PWM1::~CCH9130PWM1()
{
}

void CCH9130PWM1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCH9130PWM1)
	DDX_Control(pDX, IDC_COMBO_PWM1_POLAR, m_ctrlPolar);
	DDX_Text(pDX, IDC_EDIT_PWM1_CYC, m_uCYC);
	DDX_Text(pDX, IDC_EDIT_PWM1_DUTY, m_uDuty);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCH9130PWM1, CPropertyPage)
	//{{AFX_MSG_MAP(CCH9130PWM1)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_PWM1, OnButtonOpenPwm1)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_PWM1, OnButtonClosePwm1)
	ON_BN_CLICKED(IDC_BUTTON_INIT, OnButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_SET_DUTY, OnButtonSetDuty)
	ON_BN_CLICKED(IDC_BUTTON_START_OUT, OnButtonStartOut)
	ON_BN_CLICKED(IDC_BUTTON_STOP_OUT, OnButtonStopOut)
	ON_MESSAGE(MM_MYCHANGEDEVICE,OnMyChangeDevice)
	ON_BN_CLICKED(IDC_BUTTON_PWM_TEST, OnButtonPwmTest)
	ON_BN_CLICKED(IDC_BUTTON_STOP_TEST, OnButtonStopTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCH9130PWM1 message handlers

BOOL CCH9130PWM1::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	

	

	m_ctrlPolar.AddString(_T("Ĭϵ͵ƽ"));
	m_ctrlPolar.AddString(_T("Ĭϸߵƽ"));
	m_ctrlPolar.SetCurSel(0);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCH9130PWM1::OnButtonOpenPwm1() 
{
	// TODO: Add your control notification handler code here
	CCH9130TestApp * pThis;
	pThis = (CCH9130TestApp *) AfxGetApp();
	m_hDev = CH9130Connect(pThis->m_uIP,pThis->m_uPort);
	if(m_hDev != NULL)
	{
		USHORT DevStatus;
		if( CH9130GetDevStatus(m_hDev,&DevStatus) )
		{
			if(DevStatus & BIT_PERI_PWM1)
			{
				AfxMessageBox("豸ѾԴ");
				CH9130Disconnect(m_hDev,1000);
				m_hDev = NULL;
			}else{
				if( CH9130OpenPWM1(m_hDev) )
				{
					CH9130SetCallBack(m_hDev,PWM1RemoveCallBack,NULL);
					AfxMessageBox("PWM1򿪳ɹ");
					CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_PWM1);
					::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
				}
			}
		}
	}
}

void CCH9130PWM1::OnButtonClosePwm1() 
{
	// TODO: Add your control notification handler code here
	if(m_hDev != NULL)
	{
		if(CH9130ClosePWM1(m_hDev))
		{
			
		}
		CH9130Disconnect(m_hDev,1000);
		m_hDev = NULL;
		CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_PWM1);
		::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	}
}

void CCH9130PWM1::OnButtonInit() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}

	CString st;
	UCHAR ucRPT;
	BOOL bLoop,bPolar;
	UpdateData();


	m_ctrlPolar.GetLBText( m_ctrlPolar.GetCurSel() ,st);
	if(st == _T("Ĭϵ͵ƽ") ){
		bPolar = 0;
	}else if(st == _T("Ĭϸߵƽ")){
		bPolar = 1;
	}
	if(m_hDev != NULL)
	{
		if(CH9130InitPWM1(m_hDev,ucRPT,bLoop,bPolar,m_uCYC,m_uDuty))
		{
			
		}
	}
}

void CCH9130PWM1::OnButtonSetDuty() 
{
	// TODO: Add your control notification handler code here
	ULONG value;
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}

	value = m_uDuty;
	if(value > 100) value = 100;

	if(CH9130SetPWM1Duty(m_hDev,value))
	{
		
	}
}

void CCH9130PWM1::OnButtonStartOut() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}

	if(CH9130SetPWM1Out(m_hDev,TRUE))
	{
		
	}
}

void CCH9130PWM1::OnButtonStopOut() 
{
	// TODO: Add your control notification handler code here

	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	if(CH9130SetPWM1Out(m_hDev,FALSE))
	{
		
	}
}
LRESULT CCH9130PWM1::OnMyChangeDevice(WPARAM wParam, LPARAM lParam)
{
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_PWM1);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

UINT CCH9130PWM1::ThreadPWMTest(LPVOID pParam)
{
	CCH9130PWM1 * pThis;
	
	pThis = (CCH9130PWM1 * )pParam;

	UCHAR data;
	data = 0x0;
	while(TRUE)
	{
		if(pThis->m_bStopTest) break;
		

		if(CH9130SetPWM1Duty(pThis->m_hDev,data))
		{
			
		}
		Sleep(100);
		data ++;
		if(data > 100) data = 0;
	}
	CWnd * pwnd = pThis->GetDlgItem(IDC_BUTTON_PWM_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

void CCH9130PWM1::OnButtonPwmTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopTest = FALSE;
	
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_PWM_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	
	AfxBeginThread(ThreadPWMTest,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

void CCH9130PWM1::OnButtonStopTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopTest = TRUE;
}
