// CH9130PWM2.cpp : implementation file
//

#include "stdafx.h"
#include "ch9130test.h"
#include "CH9130PWM2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCH9130PWM2 property page
void CALLBACK PWM2RemoveCallBack(PVOID pParam)
{
	CCH9130Sheet * pSheet = (CCH9130Sheet *)AfxGetMainWnd();
	CCH9130PWM2 * pThis = (CCH9130PWM2 *)pSheet->GetPage(5);

	if(pThis->m_hDev != NULL)
	{
		CH9130Disconnect(pThis->m_hDev,1000);
		pThis->m_hDev = NULL;
		pThis->PostMessage(MM_MYCHANGEDEVICE);
	}
}

IMPLEMENT_DYNCREATE(CCH9130PWM2, CPropertyPage)

CCH9130PWM2::CCH9130PWM2() : CPropertyPage(CCH9130PWM2::IDD)
{
	//{{AFX_DATA_INIT(CCH9130PWM2)
	m_uCYC = 0;
	m_uDuty = 50;
	//}}AFX_DATA_INIT
}

CCH9130PWM2::~CCH9130PWM2()
{
}

void CCH9130PWM2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCH9130PWM2)
	DDX_Control(pDX, IDC_COMBO_PWM2_POLAR, m_ctrlPolar);
	DDX_Text(pDX, IDC_EDIT_PWM2_CYC, m_uCYC);
	DDX_Text(pDX, IDC_EDIT_PWM2_DUTY, m_uDuty);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCH9130PWM2, CPropertyPage)
	//{{AFX_MSG_MAP(CCH9130PWM2)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_PWM2, OnButtonOpenPwm2)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_PWM2, OnButtonClosePwm2)
	ON_BN_CLICKED(IDC_BUTTON_INIT, OnButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_SET_DUTY, OnButtonSetDuty)
	ON_BN_CLICKED(IDC_BUTTON_STOP_OUT, OnButtonStopOut)
	ON_BN_CLICKED(IDC_BUTTON_START_OUT, OnButtonStartOut)
	ON_MESSAGE(MM_MYCHANGEDEVICE,OnMyChangeDevice)
	ON_BN_CLICKED(IDC_BUTTON_PWM_TEST, OnButtonPwmTest)
	ON_BN_CLICKED(IDC_BUTTON_STOP_TEST, OnButtonStopTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCH9130PWM2 message handlers

void CCH9130PWM2::OnButtonOpenPwm2() 
{
	// TODO: Add your control notification handler code here
	CCH9130TestApp * pThis;
	pThis = (CCH9130TestApp *) AfxGetApp();
	m_hDev = CH9130Connect(pThis->m_uIP,pThis->m_uPort);
	if(m_hDev != NULL)
	{
		USHORT DevStatus;
		if( CH9130GetDevStatus(m_hDev,&DevStatus) )
		{
			if(DevStatus & BIT_PERI_PWM2)
			{
				AfxMessageBox("豸ѾԴ");
				CH9130Disconnect(m_hDev,1000);
				m_hDev = NULL;
			}else{
				if( CH9130OpenPWM2(m_hDev) )
				{
					CH9130SetCallBack(m_hDev,PWM2RemoveCallBack,NULL);
					AfxMessageBox("PWM2򿪳ɹ");
					CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_PWM2);
					::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
				}
			}
		}
	}
}

void CCH9130PWM2::OnButtonClosePwm2() 
{
	// TODO: Add your control notification handler code here
	if(m_hDev != NULL)
	{
		if(CH9130ClosePWM2(m_hDev))
		{
			
		}
		CH9130Disconnect(m_hDev,1000);
		m_hDev = NULL;
		CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_PWM2);
		::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	}
}

void CCH9130PWM2::OnButtonInit() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}

	CString st;
	UCHAR ucRPT;
	BOOL bLoop,bPolar;
	UpdateData();
	

	m_ctrlPolar.GetLBText( m_ctrlPolar.GetCurSel() ,st);
	if(st == _T("Ĭϵ͵ƽ") ){
		bPolar = 0;
	}else if(st == _T("Ĭϸߵƽ")){
		bPolar = 1;
	}
	if(m_hDev != NULL)
	{
		if(CH9130InitPWM2(m_hDev,ucRPT,bLoop,bPolar,m_uCYC,m_uDuty))
		{
			
		}
	}
}

BOOL CCH9130PWM2::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here

	

	

	m_ctrlPolar.AddString(_T("Ĭϵ͵ƽ"));
	m_ctrlPolar.AddString(_T("Ĭϸߵƽ"));
	m_ctrlPolar.SetCurSel(0);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCH9130PWM2::OnButtonSetDuty() 
{
	// TODO: Add your control notification handler code here
	ULONG value;
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}

	value = m_uDuty;
	if(value > 100) value = 100;

	if(CH9130SetPWM2Duty(m_hDev,value))
	{
		
	}
}

void CCH9130PWM2::OnButtonStopOut() 
{
	// TODO: Add your control notification handler code here

	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}

	if(CH9130SetPWM2Out(m_hDev,FALSE))
	{
		
	}
}

void CCH9130PWM2::OnButtonStartOut() 
{
	// TODO: Add your control notification handler code here

	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	if(CH9130SetPWM2Out(m_hDev,TRUE))
	{
		
	}
}
LRESULT CCH9130PWM2::OnMyChangeDevice(WPARAM wParam, LPARAM lParam)
{
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_PWM2);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

UINT CCH9130PWM2::ThreadPWMTest(LPVOID pParam)
{
	CCH9130PWM2 * pThis;
	
	pThis = (CCH9130PWM2 * )pParam;
	UCHAR data;
	data = 0x0;
	while(TRUE)
	{
		if(pThis->m_bStopTest) break;
		

		if(CH9130SetPWM2Duty(pThis->m_hDev,data))
		{
			
		}
		Sleep(100);
		data ++;
		if(data > 100) data = 0;
	}
	CWnd * pwnd = pThis->GetDlgItem(IDC_BUTTON_PWM_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

void CCH9130PWM2::OnButtonPwmTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopTest = FALSE;
	
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_PWM_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	
	AfxBeginThread(ThreadPWMTest,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

void CCH9130PWM2::OnButtonStopTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopTest = TRUE;
}
