// CH9130SPI0.cpp : implementation file
//

#include "stdafx.h"
#include "ch9130test.h"
#include "CH9130SPI0.h"

#include "cfile64.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCH9130SPI0 property page
void CALLBACK SPI0RemoveCallBack(PVOID pParam)
{
	CCH9130Sheet * pSheet = (CCH9130Sheet *)AfxGetMainWnd();
	CCH9130SPI0 * pThis = (CCH9130SPI0 *)pSheet->GetPage(6);

	if(pThis->m_hDev != NULL)
	{
		CH9130Disconnect(pThis->m_hDev,1000);
		pThis->m_hDev = NULL;
		pThis->PostMessage(MM_MYCHANGEDEVICE);
	}
}
IMPLEMENT_DYNCREATE(CCH9130SPI0, CPropertyPage)

CCH9130SPI0::CCH9130SPI0() : CPropertyPage(CCH9130SPI0::IDD)
{
	//{{AFX_DATA_INIT(CCH9130SPI0)
	m_ClkDiv = 2;
	m_uReadLen = 0;
	m_uWriteLen = 0;
	//}}AFX_DATA_INIT
}

CCH9130SPI0::~CCH9130SPI0()
{
}

void CCH9130SPI0::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCH9130SPI0)
	DDX_Control(pDX, IDC_COMBO_SPI0_SCK_MODE, m_ctrlSckMode);
	DDX_Control(pDX, IDC_COMBO_SPI0_MODE, m_ctrlMode);
	DDX_Text(pDX, IDC_EDIT_SPI0_CLKDIV, m_ClkDiv);
	DDV_MinMaxUInt(pDX, m_ClkDiv, 2, 255);
	DDX_Text(pDX, IDC_EDIT_READ_LEN, m_uReadLen);
	DDX_Text(pDX, IDC_EDIT_WRITE_LEN, m_uWriteLen);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCH9130SPI0, CPropertyPage)
	//{{AFX_MSG_MAP(CCH9130SPI0)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_SPI0, OnButtonOpenSpi0)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_SPI0, OnButtonCloseSpi0)
	ON_BN_CLICKED(IDC_BUTTON_INIT, OnButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_SPI0_HOST_READ, OnButtonSpi0HostRead)
	ON_BN_CLICKED(IDC_BUTTON_SPI0_HOST_WRITE, OnButtonSpi0HostWrite)
	ON_BN_CLICKED(IDC_BUTTON_WRITE_READ, OnButtonWriteRead)
	ON_BN_CLICKED(IDC_BUTTON_SPI0_DEV_READ, OnButtonSpi0DevRead)
	ON_BN_CLICKED(IDC_BUTTON_SPI0_STOP_READ, OnButtonSpi0StopRead)
	ON_BN_CLICKED(IDC_BUTTON_SPI0_DEV_WRITE, OnButtonSpi0DevWrite)
	ON_MESSAGE(MM_MYCHANGEDEVICE,OnMyChangeDevice)
	ON_BN_CLICKED(IDC_BUTTON_SEND_RECV_FILE, OnButtonSendRecvFile)
	ON_BN_CLICKED(IDC_BUTTON_SEND_FILE, OnButtonSendFile)
	ON_BN_CLICKED(IDC_BUTTON_SPI0_HOST_TEST, OnButtonSpi0HostTest)
	ON_BN_CLICKED(IDC_BUTTON_SPI0_DEVICE_TEST, OnButtonSpi0DeviceTest)
	ON_BN_CLICKED(IDC_BUTTON_SPI0_STOP_TEST, OnButtonSpi0StopTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCH9130SPI0 message handlers

void CCH9130SPI0::OnButtonOpenSpi0() 
{
	// TODO: Add your control notification handler code here
	CCH9130TestApp * pThis;
	pThis = (CCH9130TestApp *) AfxGetApp();
	m_hDev = CH9130Connect(pThis->m_uIP,pThis->m_uPort);
	if(m_hDev != NULL)
	{
		USHORT DevStatus;
		if( CH9130GetDevStatus(m_hDev,&DevStatus) )
		{
			if(DevStatus & BIT_PERI_SPI0)
			{
				AfxMessageBox("豸ѾԴ");
				CH9130Disconnect(m_hDev,1000);
				m_hDev = NULL;
			}else{
				if( CH9130OpenSPI0(m_hDev) )
				{
					CH9130SetCallBack(m_hDev,SPI0RemoveCallBack,NULL);
					AfxMessageBox("SPI0򿪳ɹ");
					CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_SPI0);
					::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
				}
			}
		}
	}
}

void CCH9130SPI0::OnButtonCloseSpi0() 
{
	// TODO: Add your control notification handler code here
	if(m_hDev != NULL)
	{
		if(CH9130CloseSPI0(m_hDev))
		{
			
		}
		CH9130Disconnect(m_hDev,1000);
		m_hDev = NULL;
		CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_SPI0);
		::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	}
}

BOOL CCH9130SPI0::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_ctrlMode.AddString(_T("ģʽ"));
	m_ctrlMode.AddString(_T("豸ģʽ"));
	m_ctrlMode.SetCurSel(0);
	
	m_ctrlSckMode.AddString(_T("ģʽ0"));
	m_ctrlSckMode.AddString(_T("ģʽ3"));
	m_ctrlSckMode.SetCurSel(0);
	


	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCH9130SPI0::OnButtonInit() 
{
	// TODO: Add your control notification handler code here
	CString st;
	BOOL bMode,bSckMode,bFcEnb;
	UpdateData();
	m_ctrlMode.GetLBText( m_ctrlMode.GetCurSel() ,st);
	if(st == _T("ģʽ") ){
		bMode = 0;
	}else if(st == _T("豸ģʽ"))
	{
		bMode = 1;
	}
	
	m_ctrlSckMode.GetLBText( m_ctrlSckMode.GetCurSel() ,st);
	if(st == _T("ģʽ0") ){
		bSckMode = 0;
	}else if(st == _T("ģʽ3"))
	{
		bSckMode = 1;
	}


	bFcEnb = 1;
	if(m_hDev != NULL)
	{
		if(CH9130InitSPI0(m_hDev,bMode,bSckMode,m_ClkDiv,bFcEnb))
		{

		}
	}
}





void CCH9130SPI0::OnButtonSpi0HostRead() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}

	PCHAR data = (PCHAR)malloc(m_uReadLen);
	PCHAR buffer = (PCHAR)malloc(m_uReadLen*2+1);
	if( CH9130ReadDataSPI0Host(m_hDev,data,m_uReadLen,1000) )
	{
		memset(buffer,0,m_uReadLen*2);
		for(UINT i = 0,j=0 ; i < m_uReadLen; i++ )
		{
			sprintf(&buffer[j],"%02X",(UCHAR)data[i]);
			j+=2;
		}
		SetDlgItemText(IDC_EDIT_DATA,buffer);
	}else AfxMessageBox("Ĵʧ");
	free(data);
	free(buffer);
}

void CCH9130SPI0::OnButtonSpi0HostWrite() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	

	PCHAR data = (PCHAR)malloc(m_uWriteLen);
	PCHAR buffer = (PCHAR)malloc(m_uWriteLen*2+1);
	if( !GetDlgItemText(IDC_EDIT_DATA,buffer,m_uWriteLen*2+1) )
	{
		AfxMessageBox("Ϊգ!");
		return;
	}
	if(!mCheckInput((PUCHAR)buffer))
	{
		AfxMessageBox("ַ0~9,a~f,A~F֮ʮ!");
		return;
	}
	//data = (USHORT)mStrToBcd(buffer);
	ULONG datalen = strlen(buffer);
	datalen = datalen &0xfffffffe;
	datalen = datalen/2;
	memset(data,0,datalen);
	for(UINT i = 0,j=0; i < datalen*2; i +=2 )
	{
		data[j] = mWordToByte(buffer[i],buffer[i+1]);
		j++;
	}
	
	
	if( CH9130WriteDataSPI0Host(m_hDev,data,datalen,1000) )
	{
		
	}else AfxMessageBox("дĴʧ");
	free(data);
	free(buffer);
}

void CCH9130SPI0::OnButtonWriteRead() 
{
	// TODO: Add your control notification handler code here
	UpdateData();

	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	

	PCHAR data = (PCHAR)malloc(m_uWriteLen);
	PCHAR buffer = (PCHAR)malloc(m_uWriteLen*2+1);
	if( !GetDlgItemText(IDC_EDIT_DATA,buffer,m_uWriteLen*2+1) )
	{
		AfxMessageBox("Ϊգ!");
		return;
	}
	if(!mCheckInput((PUCHAR)buffer))
	{
		AfxMessageBox("ַ0~9,a~f,A~F֮ʮ!");
		return;
	}
	//data = (USHORT)mStrToBcd(buffer);
	ULONG datalen = strlen(buffer);
	datalen = datalen &0xfffffffe;
	datalen = datalen/2;
	for(UINT i = 0,j=0; i < datalen*2; i +=2 )
	{
		data[j] = mWordToByte(buffer[i],buffer[i+1]);
		j++;
	}
	
	PCHAR rdata = (PCHAR)malloc(m_uReadLen);
	PCHAR rbuffer = (PCHAR)malloc(m_uReadLen*2);

	if( CH9130WriteReadSPI0Host(m_hDev,data,datalen,rdata,m_uReadLen,1000) )
	{
		memset(rbuffer,0,m_uReadLen*2);
		for(UINT i = 0,j=0 ; i < m_uReadLen; i++ )
		{
			sprintf(&rbuffer[j],"%02X",(UCHAR)rdata[i]);
			j+=2;
		}
		SetDlgItemText(IDC_EDIT_DATA,rbuffer);
	}else AfxMessageBox("дĴʧ");
	free(data);
	free(buffer);
	free(rdata);
	free(rbuffer);
}

void CCH9130SPI0::OnButtonSpi0DevRead() 
{
	// TODO: Add your control notification handler code here
	m_bStopRead = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SPI0_DEV_READ);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	AfxBeginThread(ThreadRecv,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

UINT CCH9130SPI0::ThreadRecv(LPVOID pParam)
{
	CCH9130SPI0 * pThis;
	pThis = (CCH9130SPI0 * )pParam;
	UCHAR buf[2048];
	ULONG len;
	while(TRUE)
	{	
		if(pThis->m_bStopRead) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			return 0;
		}
		len = sizeof(buf);
		memset(buf,0,sizeof(buf));
		if( CH9130ReadDataSPI0Device(pThis->m_hDev,buf,&len,5000) )
		{
			if(len != 0)
			{
				CString stFileName;
				for(UINT index = 0 ; ;index++)
				{
					stFileName.Format("SPI0DATA_%d.BIN",index);
					if( GetFileLen(stFileName) < (4194304000) ) break;  //CStdioFileִ֧4GBļ,޶ļС4000*1024*1024
				}

				CStdioFile f;
				
				if(!f.Open(stFileName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
				{
					
				   break;
				}
				f.SeekToEnd();
			
				f.Write(buf,len);
				f.Close();

			}

		}
	}
	return 0;
}

void CCH9130SPI0::OnButtonSpi0StopRead() 
{
	// TODO: Add your control notification handler code here
	m_bStopRead = TRUE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SPI0_DEV_READ);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}

void CCH9130SPI0::OnButtonSpi0DevWrite() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}
	

	PCHAR data = (PCHAR)malloc(m_uWriteLen);
	PCHAR buffer = (PCHAR)malloc(m_uWriteLen*2+1);
	if( !GetDlgItemText(IDC_EDIT_DATA,buffer,m_uWriteLen*2+1) )
	{
		AfxMessageBox("Ϊգ!");
		return;
	}
	if(!mCheckInput((PUCHAR)buffer))
	{
		AfxMessageBox("ַ0~9,a~f,A~F֮ʮ!");
		return;
	}
	//data = (USHORT)mStrToBcd(buffer);
	ULONG datalen = strlen(buffer);
	datalen = datalen &0xfffffffe;
	datalen = datalen/2;
	memset(data,0,datalen);
	for(UINT i = 0,j=0; i < datalen*2; i +=2 )
	{
		data[j] = mWordToByte(buffer[i],buffer[i+1]);
		j++;
	}
	


	if( CH9130WriteDataSPI0Device(m_hDev,data,datalen,20000) )
	{

	}else AfxMessageBox("дĴʧ");
	free(data);
	free(buffer);

}
LRESULT CCH9130SPI0::OnMyChangeDevice(WPARAM wParam, LPARAM lParam)
{
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_SPI0);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	OnButtonSpi0StopRead();
	m_bStopSend = TRUE;
	return 0;
}

void CCH9130SPI0::OnButtonSendRecvFile() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SEND_RECV_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	
	TCHAR szFilters[]= _T("BIN Files (*.BIN)|*.BIN|All Files (*.*)|*.*||");
	TCHAR CurPathName[512];
	GetCurrentDirectory(sizeof(CurPathName),CurPathName);
	// Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg(TRUE, _T("BIN"), _T("*.BIN"),
	  OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilters);

	// Display the file dialog. When user clicks OK, fileDlg.DoModal() 
	// returns IDOK.
	if(fileDlg.DoModal() == IDOK)
	{
		m_strPathName = fileDlg.GetPathName();
		SetCurrentDirectory(CurPathName);
		//AfxMessageBox(m_strPathName);
		AfxBeginThread(ThreadSendRecvFile,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
	}else ::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}

UINT CCH9130SPI0::ThreadSendRecvFile(LPVOID pParam)
{
	CCH9130SPI0 * pThis;
	CStdioFile f,fRecv;
	CString strRecvPathName;
	pThis = (CCH9130SPI0 * )pParam;
	UCHAR buf[512];
	ULONG len;
	
	strRecvPathName = pThis->m_strPathName + ".r";
	if(!f.Open(pThis->m_strPathName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
	{
	   return 0;
	}
	if(!fRecv.Open(strRecvPathName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
	{
	   return 0;
	}



	while(TRUE)
	{	
		if(pThis->m_bStopSend) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			break;
		}

		len = f.Read(buf,sizeof(buf));
		if(len > 0)
		{
		
				
			if( CH9130WriteDataSPI0Host(pThis->m_hDev,buf,len,10000) )
			{
				Sleep(200);
				if(CH9130ReadDataSPI0Host(pThis->m_hDev,buf,len,10000) )
				{
					fRecv.Write(buf,len);
				}
			}else break;

		
		}else{
			break;
		}
	}
	f.Close();
	fRecv.Close();
	CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SEND_RECV_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

UINT CCH9130SPI0::ThreadSendFile(LPVOID pParam)
{
	CCH9130SPI0 * pThis;
	CStdioFile f,fRecv;
	CString strRecvPathName;
	pThis = (CCH9130SPI0 * )pParam;
	UCHAR buf[512];
	ULONG len;
	
	strRecvPathName = pThis->m_strPathName + ".r";
	if(!f.Open(pThis->m_strPathName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
	{
	   return 0;
	}
	if(!fRecv.Open(strRecvPathName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
	{
	   return 0;
	}



	while(TRUE)
	{	
		if(pThis->m_bStopSend) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			break;
		}

		len = f.Read(buf,sizeof(buf));
		if(len > 0)
		{
		
				
			if( CH9130WriteDataSPI0Device(pThis->m_hDev,buf,len,10000) )
			{
				if(CH9130ReadDataSPI0Device(pThis->m_hDev,buf,&len,10000) )
				{
					if(len != 0)
						fRecv.Write(buf,len);
				}
			}else break;

		
		}else{
			break;
		}
	}
	f.Close();
	fRecv.Close();
	CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SEND_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

void CCH9130SPI0::OnButtonSendFile() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SEND_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	
	TCHAR szFilters[]= _T("BIN Files (*.BIN)|*.BIN|All Files (*.*)|*.*||");
	TCHAR CurPathName[512];
	GetCurrentDirectory(sizeof(CurPathName),CurPathName);
	// Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg(TRUE, _T("BIN"), _T("*.BIN"),
	  OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilters);

	// Display the file dialog. When user clicks OK, fileDlg.DoModal() 
	// returns IDOK.
	if(fileDlg.DoModal() == IDOK)
	{
		m_strPathName = fileDlg.GetPathName();
		SetCurrentDirectory(CurPathName);
		//AfxMessageBox(m_strPathName);
		AfxBeginThread(ThreadSendFile,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
	}else ::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}

UINT CCH9130SPI0::ThreadHostSendRecvTest(LPVOID pParam)
{
	CCH9130SPI0 * pThis;

	pThis = (CCH9130SPI0 * )pParam;
	UCHAR SendBuf[512],RecvBuf[512];
	ULONG len,index;
	ULONGLONG TotalByte = 0;
	index = 0;
	ULONG TestTime = 0;

	CTime TestStartTime = CTime::GetCurrentTime(); 
	CTimeSpan ts1(TestStartTime.GetDay(),TestStartTime.GetHour(),
					TestStartTime.GetMinute(),TestStartTime.GetSecond());
	UCHAR dIndex = 0;
	while(TRUE)
	{	
		if(pThis->m_bStopSend) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			break;
		}
		len = RangedRand(5,512);
		SendBuf[0] = 'S';
		SendBuf[1] = 'P';
		SendBuf[2] = 'I';
		SendBuf[3] = '0';
		dIndex = 0;
		for(UINT i = 4 ; i < len ; i ++)
		{
			//SendBuf[i] = (UCHAR)RangedRand(0,256);
			SendBuf[i] = dIndex++;
		}
		TotalByte += len;
		TestTime ++;
		//dIndex++;
		if(len > 0)
		{
		
				
			if( CH9130WriteDataSPI0Host(pThis->m_hDev,SendBuf,len,10000) )
			{
				Sleep(1);
				if(CH9130ReadDataSPI0Host(pThis->m_hDev,RecvBuf,len,10000) )
				{
					for(UINT i = 0 ; i < len ; i++)
					{
						if(SendBuf[i] != RecvBuf[i])
						{
							CTime t = CTime::GetCurrentTime();   
							CString st;
							st.Format("SPI0HOSTݱȽϴʱ䣺%s  ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
							AfxMessageBox(st);
							//break;
							CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SPI0_HOST_TEST);
							::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
							return 0;
						}
					}
				}else{
					CTime t = CTime::GetCurrentTime();   
					CString st;
					st.Format("SPI0HOSTʱ䣺%s  ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
					AfxMessageBox(st);
					break;
				}
				Sleep(1);
				index ++;
			}else{
				CTime t = CTime::GetCurrentTime();   
				CString st;
				st.Format("SPI0HOSTдʱ䣺%s  ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
				AfxMessageBox(st);
				break;
			}

			if( (TestTime%10 ) == 9)
			{
				CTime TestCurrentTime = CTime::GetCurrentTime(); 
				CTimeSpan ts2(TestCurrentTime.GetDay(),TestCurrentTime.GetHour(),
						TestCurrentTime.GetMinute(),TestCurrentTime.GetSecond());
				ts2 = ts2-ts1;
				ULONG gb = TotalByte/(0x40000000L);
				ULONG mb = (TotalByte - gb*0x40000000L)/(1024*1024);
				ULONG kb = ( TotalByte - gb*0x40000000L - mb*(1024*1024) ) /1024;
				CString st;
				st.Format("ʱ䣺%s %d ֽ%dGB.%dMB.%dKB",ts2.Format("%D days %H:%M:%S"),TestTime,gb,mb,kb);
				pThis->SetDlgItemText(IDC_EDIT_STATUS,st);
			}
		}else{
			break;
		}
	}

	CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SPI0_HOST_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

void CCH9130SPI0::OnButtonSpi0HostTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SPI0_HOST_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	AfxBeginThread(ThreadHostSendRecvTest,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

UINT CCH9130SPI0::ThreadDeviceSendRecvTest(LPVOID pParam)
{
	CCH9130SPI0 * pThis;

	pThis = (CCH9130SPI0 * )pParam;
	UCHAR SendBuf[512],RecvBuf[512];
	ULONG len,RecvLen,RecvLenTemp;
	ULONGLONG TotalByte = 0;
	ULONG TestTime = 0;

	CTime TestStartTime = CTime::GetCurrentTime(); 
	CTimeSpan ts1(TestStartTime.GetDay(),TestStartTime.GetHour(),
					TestStartTime.GetMinute(),TestStartTime.GetSecond());
	UCHAR dIndex = 0;
	while(TRUE)
	{	
		if(pThis->m_bStopSend) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			break;
		}
		len = RangedRand(7,512);
		USHORT datlen = (USHORT)(len -6);
		SendBuf[0] = 'S';
		SendBuf[1] = 'P';
		SendBuf[2] = 'I';
		SendBuf[3] = '0';
		SendBuf[4] = (UCHAR)datlen;
		SendBuf[5] = (UCHAR)(datlen>>8);
		dIndex = 0;
		for(UINT i = 6 ; i < len ; i ++)
		{
			//SendBuf[i] = (UCHAR)RangedRand(0,256);
			SendBuf[i] = dIndex++;
		}
		TotalByte += len;
		TestTime ++;
		//dIndex++;
		if(len > 0)
		{
		
				
			if( CH9130WriteDataSPI0Device(pThis->m_hDev,SendBuf,len,10000) )
			{

				RecvLen = 0;
				UINT time = 0;
				do{
					RecvLenTemp = len-RecvLen;
					if(CH9130ReadDataSPI0Device(pThis->m_hDev,&RecvBuf[RecvLen],&RecvLenTemp,1000) )
					{
						RecvLen += RecvLenTemp;
						time ++;
					}else{
						CTime t = CTime::GetCurrentTime();   
						CString st;
						st.Format("SPI0Deviceݴʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
						AfxMessageBox(st);
						CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SPI0_DEVICE_TEST);
						::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
						return 0;
					}
					if(RecvLen == len) break;
					if(time > 10) break;
				}while(TRUE);
				

				if(RecvLen != len)
				{
					CTime t = CTime::GetCurrentTime();   
					CString st;
					st.Format("SPI0Deviceݳȴʱ䣺%s  ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
					AfxMessageBox(st);
					break;
				}
				for(UINT i = 0 ; i < len ; i++)
				{
					if(SendBuf[i] != RecvBuf[i])
					{
						CTime t = CTime::GetCurrentTime();   
						CString st;
						st.Format("SPI0DeviceݱȽϴʱ䣺%s  ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
						AfxMessageBox(st);
						//break;
						CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SPI0_DEVICE_TEST);
						::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
						return 0;
					}
				}

			

			}else{
				CTime t = CTime::GetCurrentTime();   
				CString st;
				st.Format("SPI0HOSTдʱ䣺%s  ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
				AfxMessageBox(st);
				break;
			}
			if( (TestTime%10 ) == 9)
			{
				CTime TestCurrentTime = CTime::GetCurrentTime(); 
				CTimeSpan ts2(TestCurrentTime.GetDay(),TestCurrentTime.GetHour(),
						TestCurrentTime.GetMinute(),TestCurrentTime.GetSecond());
				ts2 = ts2-ts1;
				ULONG gb = TotalByte/(0x40000000L);
				ULONG mb = (TotalByte - gb*0x40000000L)/(1024*1024);
				ULONG kb = ( TotalByte - gb*0x40000000L - mb*(1024*1024) ) /1024;
				CString st;
				st.Format("ʱ䣺%s %d ֽ%dGB.%dMB.%dKB",ts2.Format("%D days %H:%M:%S"),TestTime,gb,mb,kb);
				pThis->SetDlgItemText(IDC_EDIT_STATUS,st);
			}
		
		}else{
			break;
		}
	}

	CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SPI0_DEVICE_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

void CCH9130SPI0::OnButtonSpi0DeviceTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SPI0_DEVICE_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	AfxBeginThread(ThreadDeviceSendRecvTest,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

void CCH9130SPI0::OnButtonSpi0StopTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = TRUE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SPI0_DEVICE_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	pwnd = GetDlgItem(IDC_BUTTON_SPI0_HOST_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}
