// CH9130Test.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "CH9130Test.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "CH9130Sheet.h"
#include "CH9130ADC.h"
#include "CH9130GPIO.h"
#include "CH9130PWM0.h"
#include "CH9130PWM1.h"
#include "CH9130PWM2.h"
#include "CH9130SPI0.h"
#include "CH9130SPI1.h"
#include "CH9130UART0.h"
#include "CH9130UART1.h"
#include "CH9130PARA.h"
/////////////////////////////////////////////////////////////////////////////
// CCH9130TestApp

BEGIN_MESSAGE_MAP(CCH9130TestApp, CWinApp)
	//{{AFX_MSG_MAP(CCH9130TestApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCH9130TestApp construction

CCH9130TestApp::CCH9130TestApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CCH9130TestApp object

CCH9130TestApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CCH9130TestApp initialization

BOOL CCH9130TestApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	//CCH9130TestDlg dlg;
	CH9130Init();
	ReadCfg();

	CCH9130Sheet sheet("CH9130Test");
	CCH9130GPIO gpiodlg;
	CCH9130ADC  adcdlg;
	CCH9130PWM0 pwm0dlg;
	CCH9130PWM1 pwm1dlg;
	CCH9130PWM2 pwm2dg;
	CCH9130SPI0 spi0dlg;
	CCH9130SPI1 spi1dlg;
	CCH9130UART0 uart0dlg;
	CCH9130UART1 uart1dlg;
	CCH9130PARA paradlg;

	sheet.AddPage(&gpiodlg);
	sheet.AddPage(&uart0dlg);
	sheet.AddPage(&uart1dlg);
	sheet.AddPage(&pwm0dlg);
	sheet.AddPage(&pwm1dlg);
	sheet.AddPage(&pwm2dg);
	sheet.AddPage(&spi0dlg);
	sheet.AddPage(&spi1dlg);
	sheet.AddPage(&adcdlg);
	sheet.AddPage(&paradlg);

	m_pMainWnd = &sheet;
	int nResponse = sheet.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

BOOL CCH9130TestApp::ReadCfg()
{
	CStdioFile f;
	TCHAR* pFileName = _T("cfg.txt");
	if(!f.Open(pFileName, CFile::modeReadWrite  
	   | CFile::typeText)) 
	{
	   AfxMessageBox(_T("cfg.txtʧ"));
	   return FALSE;
	}
	CString st;
	while(f.ReadString(st))
	{
		st.Replace('\t',' ');  //滻TAB
		st.TrimLeft(' ');
		st.TrimRight(' ');
		
		//ע
		INT iEnd = st.Find("//");
		if(iEnd != -1 )
		{
			if(iEnd == 0)
			{
				continue;
			}else{
				st = st.Left(iEnd);
				st.TrimLeft(' ');
				st.TrimRight(' ');
			}
		}
		st.MakeUpper();

		iEnd = st.Find("IP");
		if( iEnd != -1)
		{
			st = st.Right(st.GetLength() - 2 );	//2ֽΪIP
			st.TrimLeft(' ');
			st.TrimRight(' ');
			st = st.Right(st.GetLength() - 1 );	//1ֽΪ=
			st.TrimLeft(' ');
			st.TrimRight(' ');
			m_uIP = CH9130StrToAddr((LPCTSTR)st);
		}
		
		iEnd = st.Find("PORT");
		if( iEnd != -1)
		{
			st = st.Right(st.GetLength() - 4 );	//4ֽΪPORT
			st.TrimLeft(' ');
			st.TrimRight(' ');
			st = st.Right(st.GetLength() - 1 );	//1ֽΪ=
			st.TrimLeft(' ');
			st.TrimRight(' ');
			m_uPort = (USHORT)atol((LPCTSTR)st);
		}
	}
	f.Close();
	return TRUE;
}
