// CH9130UART1.cpp : implementation file
//

#include "stdafx.h"
#include "ch9130test.h"
#include "CH9130UART1.h"

#include "cfile64.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCH9130UART1 property page
void CALLBACK UART1RemoveCallBack(PVOID pParam)
{
	CCH9130Sheet * pSheet = (CCH9130Sheet *)AfxGetMainWnd();
	CCH9130UART1 * pThis = (CCH9130UART1 *)pSheet->GetPage(2);

	if(pThis->m_hDev != NULL)
	{
		CH9130Disconnect(pThis->m_hDev,1000);
		pThis->m_hDev = NULL;
		pThis->PostMessage(MM_MYCHANGEDEVICE);
	}
}

IMPLEMENT_DYNCREATE(CCH9130UART1, CPropertyPage)

CCH9130UART1::CCH9130UART1() : CPropertyPage(CCH9130UART1::IDD)
{
	//{{AFX_DATA_INIT(CCH9130UART1)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CCH9130UART1::~CCH9130UART1()
{
}

void CCH9130UART1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCH9130UART1)
	DDX_Control(pDX, IDC_COMBO_HALF, m_ctrlHalf);
	DDX_Control(pDX, IDC_COMBO_FLOW, m_ctrlFlow);
	DDX_Control(pDX, IDC_COMBO_STOP, m_ctrlStop);
	DDX_Control(pDX, IDC_COMBO_RATE, m_ctrlRate);
	DDX_Control(pDX, IDC_COMBO_DATA, m_ctrlData);
	DDX_Control(pDX, IDC_COMBO_CHECK, m_ctrlCheck);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCH9130UART1, CPropertyPage)
	//{{AFX_MSG_MAP(CCH9130UART1)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_UART1, OnButtonOpenUart1)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_UART1, OnButtonCloseUart1)
	ON_BN_CLICKED(IDC_BUTTON_SET, OnButtonSet)
	ON_BN_CLICKED(IDC_BUTTON_READ_DATA, OnButtonReadData)
	ON_BN_CLICKED(IDC_BUTTON_STOP_READ, OnButtonStopRead)
	ON_BN_CLICKED(IDC_BUTTON_WRITE_DATA, OnButtonWriteData)
	ON_MESSAGE(MM_MYCHANGEDEVICE,OnMyChangeDevice)
	ON_BN_CLICKED(IDC_BUTTON_TEST, OnButtonTest)
	ON_BN_CLICKED(IDC_BUTTON_STOP_TEST, OnButtonStopTest)
	ON_BN_CLICKED(IDC_BUTTON_SEND_FILE, OnButtonSendFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCH9130UART1 message handlers

void CCH9130UART1::OnButtonOpenUart1() 
{
	// TODO: Add your control notification handler code here
	CCH9130TestApp * pThis;
	pThis = (CCH9130TestApp *) AfxGetApp();
	m_hDev = CH9130Connect(pThis->m_uIP,pThis->m_uPort);
	if(m_hDev != NULL)
	{
		USHORT DevStatus;
		if( CH9130GetDevStatus(m_hDev,&DevStatus) )
		{
			if(DevStatus & BIT_PERI_UART1)
			{
				AfxMessageBox("豸ѾԴ");
				CH9130Disconnect(m_hDev,1000);
				m_hDev = NULL;
			}else{
				if( CH9130OpenUART1(m_hDev) )
				{
					CH9130SetCallBack(m_hDev,UART1RemoveCallBack,NULL);
					AfxMessageBox("UART1򿪳ɹ");
					CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_UART1);
					::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
				}
			}
		}
	}
}

void CCH9130UART1::OnButtonCloseUart1() 
{
	// TODO: Add your control notification handler code here
	if(m_hDev != NULL)
	{
		if(CH9130CloseUART1(m_hDev))
		{
			
		}
		CH9130Disconnect(m_hDev,1000);
		m_hDev = NULL;
		CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_UART1);
		::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	}
}

BOOL CCH9130UART1::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_ctrlRate.AddString(_T("Ĭ(9600)"));
	m_ctrlRate.AddString(_T("300"));
	m_ctrlRate.AddString(_T("600"));
	m_ctrlRate.AddString(_T("1200"));
	m_ctrlRate.AddString(_T("2400"));
	m_ctrlRate.AddString(_T("4800"));
	m_ctrlRate.AddString(_T("9600"));
	m_ctrlRate.AddString(_T("14400"));
	m_ctrlRate.AddString(_T("19200"));
	m_ctrlRate.AddString(_T("28800"));
	m_ctrlRate.AddString(_T("38400"));
	m_ctrlRate.AddString(_T("57600"));
	m_ctrlRate.AddString(_T("76800"));
	m_ctrlRate.AddString(_T("115200"));
	m_ctrlRate.AddString(_T("230400"));
	m_ctrlRate.AddString(_T("460800"));
	m_ctrlRate.AddString(_T("921600"));
//	m_ctrlRate.AddString(_T("1000000"));
	m_ctrlRate.SetCurSel(0);
	m_ctrlStop.AddString(_T("Ĭ(1λ)"));
	m_ctrlStop.AddString(_T("1λ"));
	m_ctrlStop.AddString(_T("2λ"));
	m_ctrlStop.SetCurSel(0);
	m_ctrlCheck.AddString(_T("Ĭ(У)"));
	m_ctrlCheck.AddString(_T("У"));
	m_ctrlCheck.AddString(_T("żУ"));
	m_ctrlCheck.AddString(_T("־λ"));
	m_ctrlCheck.AddString(_T("հλ"));
	m_ctrlCheck.AddString(_T("У"));
	m_ctrlCheck.SetCurSel(0);

	m_ctrlData.AddString(_T("Ĭ(8λ)"));
	m_ctrlData.AddString(_T("5λ"));
	m_ctrlData.AddString(_T("6λ"));
	m_ctrlData.AddString(_T("7λ"));
	m_ctrlData.AddString(_T("8λ"));
	m_ctrlData.SetCurSel(0);

	m_ctrlFlow.AddString(_T("ֹ"));
	m_ctrlFlow.AddString(_T("ʹ"));
	m_ctrlFlow.SetCurSel(0);
	
	m_ctrlHalf.AddString(_T("ֹ"));
	m_ctrlHalf.AddString(_T("ʹ"));
	m_ctrlHalf.SetCurSel(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCH9130UART1::OnButtonSet() 
{
	// TODO: Add your control notification handler code here
	CString st;
	ULONG ulRate;
	m_ctrlRate.GetLBText( m_ctrlRate.GetCurSel() ,st);
	if(st == _T("Ĭ(9600)") ){
		ulRate = 9600;
	}else if(st == _T("300")){
		ulRate = 300;
	}else if(st == _T("600")){
		ulRate = 600;
	}else if(st == _T("1200")){
		ulRate = 1200;
	}else if(st == _T("2400")){
		ulRate = 2400;
	}else if(st == _T("4800")){
		ulRate = 4800;
	}else if(st == _T("9600")){
		ulRate = 9600;
	}else if(st == _T("14400")){
		ulRate = 14400;
	}else if(st == _T("19200")){
		ulRate = 19200;
	}else if(st == _T("28800")){
		ulRate = 28800;
	}else if(st == _T("38400")){
		ulRate = 38400;
	}else if(st == _T("57600")){
		ulRate = 57600;
	}else if(st == _T("76800")){
		ulRate = 76800;
	}else if(st == _T("115200")){
		ulRate = 115200;
	}else if(st == _T("230400")){
		ulRate = 230400;
	}else if(st == _T("460800")){
		ulRate = 460800;
	}else if(st == _T("921600")){
		ulRate = 921600;
	}

	UCHAR ucCheck;
	m_ctrlCheck.GetLBText( m_ctrlCheck.GetCurSel() ,st);
	if(st == _T("Ĭ(У)") ){
		ucCheck = 4;
	}else if( st == _T("У") ){
		ucCheck = 0;
	}else if( st == _T("żУ") ){
		ucCheck = 1;
	}else if( st == _T("־λ") ){
		ucCheck = 2;
	}else if( st == _T("հλ") ){
		ucCheck = 3;
	}else if( st == _T("У") ){
		ucCheck = 4;
	}
	UCHAR ucStop;
	m_ctrlStop.GetLBText( m_ctrlStop.GetCurSel() ,st);
	if(st == _T("Ĭ(1λ)") ){
		ucStop = 0;
	}else if( st == _T("1λ")  ){
		ucStop = 0;
	}else if( st == _T("2λ")  ){
		ucStop = 1;
	}
	UCHAR ucData;
	m_ctrlData.GetLBText( m_ctrlData.GetCurSel() ,st);
	if(st == _T("Ĭ(8λ)") ){
		ucData = 3;
	}else if( st == _T("5λ")  ){
		ucData = 0;
	}else if( st == _T("6λ")  ){
		ucData = 1;
	}else if( st == _T("7λ")  ){
		ucData = 2;
	}else if( st == _T("8λ")  ){
		ucData = 3;
	}
	

	UCHAR ucFlowCtrl = FALSE;
	m_ctrlFlow.GetLBText( m_ctrlFlow.GetCurSel() ,st);
	if(st == _T("ֹ") ){
		ucFlowCtrl = 0;
	}else if(st == _T("ʹ"))
	{
		ucFlowCtrl = 1;
	}
	BOOL bHalf;
	
	m_ctrlHalf.GetLBText( m_ctrlHalf.GetCurSel() ,st);
	if(st == _T("ֹ") ){
		bHalf = 0;
	}else if(st == _T("ʹ"))
	{
		bHalf = 1;
	}

	UCHAR ucFifo = 0x01;

	if(m_hDev != NULL)
	{
		if(CH9130InitUART1(m_hDev,ulRate,ucCheck,ucStop,ucData,ucFifo,ucFlowCtrl,bHalf))
		{

		}
	}
}



void CCH9130UART1::OnButtonReadData() 
{
	// TODO: Add your control notification handler code here
	m_bStopRead = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_READ_DATA);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	AfxBeginThread(ThreadRecv,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

UINT CCH9130UART1::ThreadRecv(LPVOID pParam)
{
	CCH9130UART1 * pThis;
	pThis = (CCH9130UART1 * )pParam;
	UCHAR buf[2048];
	ULONG len;
	while(TRUE)
	{	
		if(pThis->m_bStopRead) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			return 0;
		}
		len = sizeof(buf);
		memset(buf,0,sizeof(buf));
		if( CH9130ReadUART1Data(pThis->m_hDev,buf,&len,100) )
		{
			if(len != 0)
			{
				CString stFileName;
				for(UINT index = 0 ; ;index++)
				{
					stFileName.Format("UART1DATA_%d.BIN",index);
					if( GetFileLen(stFileName) < (4194304000) ) break;  //CStdioFileִ֧4GBļ,޶ļС4000*1024*1024
				}

				CStdioFile f;
				
				if(!f.Open(stFileName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
				{
					
				   break;
				}
				f.SeekToEnd();
			
				f.Write(buf,len);
				f.Close();
			}

		}
	}
	return 0;
}

void CCH9130UART1::OnButtonStopRead() 
{
	// TODO: Add your control notification handler code here
	m_bStopRead = TRUE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_READ_DATA);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}

void CCH9130UART1::OnButtonWriteData() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	
	
	ULONG uWriteLen ;
	uWriteLen = ::GetWindowTextLength(GetDlgItem(IDC_EDIT_DATA)->GetSafeHwnd());
	
	if(m_hDev == NULL)
	{
		AfxMessageBox("豸δӣ豸!");
		return;
	}

	PCHAR data = (PCHAR)malloc(uWriteLen);
	PCHAR buffer = (PCHAR)malloc(uWriteLen*2+1);
	if( !GetDlgItemText(IDC_EDIT_DATA,buffer,uWriteLen*2+1) )
	{
		AfxMessageBox("Ϊգ!");
		return;
	}
	if(!mCheckInput((PUCHAR)buffer))
	{
		AfxMessageBox("ַ0~9,a~f,A~F֮ʮ!");
		return;
	}
	//data = (USHORT)mStrToBcd(buffer);
	ULONG datalen = strlen(buffer);
	datalen = datalen &0xfffffffe;
	datalen = datalen/2;
	for(UINT i = 0,j=0; i < datalen*2; i +=2 )
	{
		data[j] = mWordToByte(buffer[i],buffer[i+1]);
		j++;
	}
	


	if( CH9130WriteUART1Data(m_hDev,data,datalen,1000) )
	{

	}else AfxMessageBox("дĴʧ");
	free(data);
	free(buffer);
}

LRESULT CCH9130UART1::OnMyChangeDevice(WPARAM wParam, LPARAM lParam)
{
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_OPEN_UART1);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	OnButtonStopRead();
	OnButtonStopTest() ;
	return 0;
}


UINT CCH9130UART1::ThreadSend(LPVOID pParam)
{
	CCH9130UART1 * pThis;

	pThis = (CCH9130UART1 * )pParam;
	UCHAR SendBuf[512],RecvBuf[512];
	ULONG len,RecvLen,RecvLenTemp;
	LONGLONG TotalByte = 0;

	ULONG TestTime = 0;

	CTime TestStartTime = CTime::GetCurrentTime(); 
	CTimeSpan ts1(TestStartTime.GetDay(),TestStartTime.GetHour(),
					TestStartTime.GetMinute(),TestStartTime.GetSecond());

	while(TRUE)
	{	
		if(pThis->m_bStopSend) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			break;
		}
		len = RangedRand(6,512);
		//len = 8;
		SendBuf[0] = 'U';
		SendBuf[1] = 'A';
		SendBuf[2] = 'R';
		SendBuf[3] = 'T';
		SendBuf[4] = '1';
		for(UINT i = 5 ; i < len ; i ++)
		{
			SendBuf[i] = (UCHAR)RangedRand(0,256);
		}
		TotalByte += len;
		TestTime ++;
		if(len > 0)
		{
		
				
			if( CH9130WriteUART1Data(pThis->m_hDev,SendBuf,len,10000) )
			{
				Sleep(1);
				RecvLen = 0;
				UINT time = 0;
				do{
					RecvLenTemp = len-RecvLen;
					if(CH9130ReadUART1Data(pThis->m_hDev,&RecvBuf[RecvLen],&RecvLenTemp,1000) )
					{
						RecvLen += RecvLenTemp;
						time ++;
					}else{
						CTime t = CTime::GetCurrentTime();   
						CString st;
						st.Format("UART1ʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
						AfxMessageBox(st);
						CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_TEST);
						::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
						return 0;
					}
					if(RecvLen == len) break;
					if(time > 10) break;
				}while(TRUE);
				
				if(RecvLen != len)
				{
				
					CTime t = CTime::GetCurrentTime();   
					CString st;
					st.Format("UART1ݳȴʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
					AfxMessageBox(st);
					break;
			
				}
				for(UINT i = 0 ; i < len ; i++)
				{
					if(SendBuf[i] != RecvBuf[i])
					{
						CTime t = CTime::GetCurrentTime();   
						CString st;
						st.Format("UART1ݱȽϴʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
						AfxMessageBox(st);
						//break;
						CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_TEST);
						::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
						return 0;
					}
				}
			}else{
				CTime t = CTime::GetCurrentTime();   
				CString st;
				st.Format("UART1дʱ䣺%s ֽ0x%08X%08X",t.Format("%m-%d %H:%M:%S"),(ULONG)(TotalByte>>32),(ULONG)(TotalByte));
				AfxMessageBox(st);
				break;
			}

			if( (TestTime%10 ) == 9)
			{
				CTime TestCurrentTime = CTime::GetCurrentTime(); 
				CTimeSpan ts2(TestCurrentTime.GetDay(),TestCurrentTime.GetHour(),
						TestCurrentTime.GetMinute(),TestCurrentTime.GetSecond());
				ts2 = ts2-ts1;
				ULONG gb = TotalByte/(0x40000000L);
				ULONG mb = (TotalByte - gb*0x40000000L)/(1024*1024);
				ULONG kb = ( TotalByte - gb*0x40000000L - mb*(1024*1024) ) /1024;
				CString st;
				st.Format("ʱ䣺%s %d ֽ%dGB.%dMB.%dKB",ts2.Format("%D days %H:%M:%S"),TestTime,gb,mb,kb);
				pThis->SetDlgItemText(IDC_EDIT_STATUS,st);
			}
		}else{
			break;
		}
	}

	CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	return 0;
}

void CCH9130UART1::OnButtonTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	AfxBeginThread(ThreadSend,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
}

void CCH9130UART1::OnButtonStopTest() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = TRUE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_TEST);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
	pwnd = GetDlgItem(IDC_BUTTON_SEND_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}

void CCH9130UART1::OnButtonSendFile() 
{
	// TODO: Add your control notification handler code here
	m_bStopSend = FALSE;
	CWnd * pwnd = GetDlgItem(IDC_BUTTON_SEND_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),FALSE);
	
	TCHAR szFilters[]= _T("BIN Files (*.BIN)|*.BIN|All Files (*.*)|*.*||");
	TCHAR CurPathName[512];
	GetCurrentDirectory(sizeof(CurPathName),CurPathName);
	// Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg(TRUE, _T("BIN"), _T("*.BIN"),
	  OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilters);

	// Display the file dialog. When user clicks OK, fileDlg.DoModal() 
	// returns IDOK.
	if(fileDlg.DoModal() == IDOK)
	{
		m_strPathName = fileDlg.GetPathName();
		SetCurrentDirectory(CurPathName);
		//AfxMessageBox(m_strPathName);
		AfxBeginThread(ThreadSendFile,this,THREAD_PRIORITY_NORMAL,0,0,NULL); 
	}else ::EnableWindow(pwnd->GetSafeHwnd(),TRUE);
}

UINT CCH9130UART1::ThreadSendFile(LPVOID pParam)
{
	CCH9130UART1 * pThis;
	CStdioFile f;
	pThis = (CCH9130UART1 * )pParam;
	UCHAR buf[512];
	ULONG len;
	
	if(!f.Open(pThis->m_strPathName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeReadWrite  | CFile::shareDenyNone | CFile::typeBinary )) 
	{
	   return 0;
	}
	while(TRUE)
	{	
		if(pThis->m_bStopSend) break;
		if(pThis->m_hDev == NULL)
		{
		//	AfxMessageBox("豸δӣ豸!");
			break;
		}

		len = f.Read(buf,sizeof(buf));
		if(len > 0)
		{
			if( !CH9130WriteUART1Data(pThis->m_hDev,buf,len,10000) )
			{
				break;
			}
		}else{
			break;
		}
	}
	f.Close();

	CWnd * 	pwnd = pThis->GetDlgItem(IDC_BUTTON_SEND_FILE);
	::EnableWindow(pwnd->GetSafeHwnd(),TRUE);

	return 0;
}
